/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/complex.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_complex.h"
#include "pmc_default.h"
#include "complex.str"
#include "pmc_continuation.h"
#include "pmc_callcontext.h"
#line 1 "./src/pmc/complex.pmc"
/*
Copyright (C) 2004-2010, Parrot Foundation.
$Id: complex.pmc 48883 2010-09-09 13:45:02Z whiteknight $

=head1 NAME

src/pmc/complex.pmc - Complex Numbers PMC Class

=head1 DESCRIPTION

C<Complex> provides a representation of complex numbers. It handles
string parsing/generating and basic mathematical operations.

=head2 Functions

Equations used are sometimes listed.  At times, multiple equations are given,
but those starting with => are the ones used

=over 4

=cut

*/

/* HEADERIZER HFILE: none */
/* HEADERIZER BEGIN: static */
/* Don't modify between HEADERIZER BEGIN / HEADERIZER END.  Your changes will be lost. */

static void complex_check_divide_zero(PARROT_INTERP, ARGIN(PMC *value))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2);

static void complex_parse_string(PARROT_INTERP,
    ARGOUT(FLOATVAL *re),
    ARGOUT(FLOATVAL *im),
    ARGIN(STRING *value))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(3)
        __attribute__nonnull__(4)
        FUNC_MODIFIES(*re)
        FUNC_MODIFIES(*im);

static void float_check_divide_zero(PARROT_INTERP, FLOATVAL value)
        __attribute__nonnull__(1);

static void int_check_divide_zero(PARROT_INTERP, INTVAL value)
        __attribute__nonnull__(1);

#define ASSERT_ARGS_complex_check_divide_zero __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(value))
#define ASSERT_ARGS_complex_parse_string __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(re) \
    , PARROT_ASSERT_ARG(im) \
    , PARROT_ASSERT_ARG(value))
#define ASSERT_ARGS_float_check_divide_zero __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp))
#define ASSERT_ARGS_int_check_divide_zero __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp))
/* Don't modify between HEADERIZER BEGIN / HEADERIZER END.  Your changes will be lost. */
/* HEADERIZER END: static */

/*

=item C<static void complex_parse_string(PARROT_INTERP, FLOATVAL *re, FLOATVAL
*im, STRING *value)>

Parses the string in C<value> to produce a complex number, represented
by the real (C<*re>) and imaginary (C<*im>) parts. Raises an exception
if it cannot understand the string.  The string should be of the form
C<a+bi> with optional spaces around C<+> and before C<i>. You can also
use C<j> instead of C<i>.

=cut

We have a conflict among our coding standards here.  Our 100-character line
limit meant that the following function declaration had to be split over two
lines.  However, that leads to t/codingstd/pmc_docs.t reporting that this
function lacks documentation -- reporting due to differences in whitespacing
between '=item' and function declaration.

*/

static void
complex_parse_string(PARROT_INTERP,
                     ARGOUT(FLOATVAL *re), ARGOUT(FLOATVAL *im), ARGIN(STRING *value))
{
    ASSERT_ARGS(complex_parse_string)

    char   * const str        = Parrot_str_to_cstring(interp, value);
    char   *t                 = str;
    char   *first_num_offset  = str;
    char   *second_num_offset = NULL;
    STRING *S;

    INTVAL  i                 = 0;
    INTVAL  first_num_minus   = 0;
    INTVAL  second_num_minus  = 0;
    UINTVAL first_num_length, second_num_length;

    /* walk the string and identify the real and imaginary parts */

    if (*t == '-') {
        /* first number is negative */
        ++t;
        first_num_minus = 1;

        /* allow for an optional space */
        if (*t == ' ')
            ++t;
        first_num_offset = t;
    }

    /* skip digits */
    while (*t >= '0' && *t <= '9')
        ++t;

    if (*t == '.') {
        /* this number has a decimal point */
        ++t;

        /* skip digits */
        while (*t >= '0' && *t <= '9')
            ++t;
    }

    /* save the length of the real part */
    first_num_length = t - first_num_offset;

    /* end of string; we only have a real part */
    if (*t == 0) {
        second_num_length = 0;
    }
    else if ((*t == 'i' || *t == 'j') && *(t+1) == 0) {
        /* there is only an imaginary part, so the first number was
            actually the imaginary part */
        second_num_length = first_num_length;
        first_num_length  = 0;
        second_num_offset = first_num_offset;
        second_num_minus  = first_num_minus;
        first_num_minus   = 0;

        /* this is useful if there is no number for
            the imaginary part, like in "-i" */
        i = 1;
    }
    else {
        /* skip an optional space */
        if (*t == ' ')
            ++t;

        /* expect "+" or "-" and the imaginary part */
        if (*t == '+' || *t == '-') {
            /* save the sign */
            second_num_minus = (*t == '-');
            ++t;

            /* skip another optional space */
            if (*t == ' ')
                ++t;

            /* save the beginning of the imaginary part */
            second_num_offset = t;

            /* skip digits */
            while (*t >= '0' && *t <= '9')
                ++t;

            if (*t == '.') {
                /* this number has a decimal point */
                ++t;

                /* skip digits */
                while (*t >= '0' && *t <= '9')
                    ++t;
            }

            /* save the length of the imaginary part */
            second_num_length = t - second_num_offset;

            /* allow for one more optional space */
            if (*t == ' ')
                ++t;

            /* verify that the string ends properly */
            if ((*t != 'i' && *t != 'j') || (*(t+1) != 0)) {
                /* imaginary part does not end in 'i' or 'j' */
                Parrot_ex_throw_from_c_args(interp, NULL,
                    EXCEPTION_INVALID_STRING_REPRESENTATION,
                    "Complex: malformed string");
            }

            /* this is useful if there is no number for the
                imaginary part, like in "2+i" */
            i = 1;

            /* all is OK, save the number */
        }
        else {
            /* "+" or "-" not found: error */
            Parrot_str_free_cstring(str);

            Parrot_ex_throw_from_c_args(interp, NULL,
                EXCEPTION_INVALID_STRING_REPRESENTATION,
                "Complex: malformed string");
        }
    }

    /* now we have the offsets and the lengths we turn them into float values */

    if (first_num_length) {
        /* there is a real part, interpret it */
        S   = Parrot_str_new(interp, first_num_offset, first_num_length);
        *re = Parrot_str_to_num(interp, S);
    }
    else {
        /* consider the real part 0.0 */
        *re = 0.0;
    }

    if (second_num_length) {
        /* there is an imaginary part, interpret it */
        S   = Parrot_str_new(interp, second_num_offset, second_num_length);
        *im = Parrot_str_to_num(interp, S);
    }
    else {
        /* consider the imaginary part 0.0 */
        if (i) /* the string was something like "1+i" */
            *im = 1.0;
        else
            *im = 0.0;
    }

    if (first_num_minus)
        *re = -*re;

    if (second_num_minus)
        *im = -*im;

    Parrot_str_free_cstring(str);
}

/*

=item C<static void int_check_divide_zero(PARROT_INTERP, INTVAL value)>

=cut

*/

static void
int_check_divide_zero(PARROT_INTERP, INTVAL value)
{
    ASSERT_ARGS(int_check_divide_zero)

    if (value == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
            "Divide by zero");
}

/*

=item C<static void float_check_divide_zero(PARROT_INTERP, FLOATVAL value)>

=cut

*/

static void
float_check_divide_zero(PARROT_INTERP, FLOATVAL value)
{
    ASSERT_ARGS(float_check_divide_zero)

    if (FLOAT_IS_ZERO(value))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
            "Divide by zero");
}

/*

=item C<static void complex_check_divide_zero(PARROT_INTERP, PMC *value)>

=cut

*/

static void
complex_check_divide_zero(PARROT_INTERP, ARGIN(PMC *value))
{
    ASSERT_ARGS(complex_check_divide_zero)

    /* Throw an exception if we are dividing by zero. Check both the real part
     * and the imaginary part.*/

    if (FLOAT_IS_ZERO(VTABLE_get_number_keyed_int(interp, value, 0))
            && FLOAT_IS_ZERO(VTABLE_get_number_keyed_int(interp, value, 1)))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
            "Divide by zero");
}
#line 325 "./src/pmc/complex.c"
static  PMC  * Parrot_Complex_absolute(PARROT_INTERP, PMC *_self, PMC *dest);
static  PMC * Parrot_Complex_add(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest);
static  PMC  * Parrot_Complex_add_float(PARROT_INTERP, PMC *_self, FLOATVAL value, PMC *dest);
static  PMC  * Parrot_Complex_add_int(PARROT_INTERP, PMC *_self, INTVAL value, PMC *dest);
static  PMC  * Parrot_Complex_clone(PARROT_INTERP, PMC *_self);
static  PMC * Parrot_Complex_divide(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest);
static  PMC  * Parrot_Complex_divide_float(PARROT_INTERP, PMC *_self, FLOATVAL value, PMC *dest);
static  PMC  * Parrot_Complex_divide_int(PARROT_INTERP, PMC *_self, INTVAL value, PMC *dest);
static  void  Parrot_Complex_freeze(PARROT_INTERP, PMC *_self, PMC *visit);
static  INTVAL  Parrot_Complex_get_bool(PARROT_INTERP, PMC *_self);
static  INTVAL  Parrot_Complex_get_integer(PARROT_INTERP, PMC *_self);
static  INTVAL  Parrot_Complex_get_integer_keyed(PARROT_INTERP, PMC *_self, PMC *key);
static  INTVAL  Parrot_Complex_get_integer_keyed_str(PARROT_INTERP, PMC *_self, STRING *key);
static  FLOATVAL  Parrot_Complex_get_number(PARROT_INTERP, PMC *_self);
static  FLOATVAL  Parrot_Complex_get_number_keyed(PARROT_INTERP, PMC *_self, PMC *key);
static  FLOATVAL  Parrot_Complex_get_number_keyed_int(PARROT_INTERP, PMC *_self, INTVAL key);
static  FLOATVAL  Parrot_Complex_get_number_keyed_str(PARROT_INTERP, PMC *_self, STRING *key);
static  PMC  * Parrot_Complex_get_pmc_keyed(PARROT_INTERP, PMC *_self, PMC *key);
static  PMC  * Parrot_Complex_get_pmc_keyed_int(PARROT_INTERP, PMC *_self, INTVAL key);
static  PMC  * Parrot_Complex_get_pmc_keyed_str(PARROT_INTERP, PMC *_self, STRING *key);
static  STRING  * Parrot_Complex_get_string(PARROT_INTERP, PMC *_self);
static  void  Parrot_Complex_i_absolute(PARROT_INTERP, PMC *_self);
static  void Parrot_Complex_i_add(PARROT_INTERP, PMC *_self, PMC *value);
static  void  Parrot_Complex_i_add_float(PARROT_INTERP, PMC *_self, FLOATVAL value);
static  void  Parrot_Complex_i_add_int(PARROT_INTERP, PMC *_self, INTVAL value);
static  void Parrot_Complex_i_divide(PARROT_INTERP, PMC *_self, PMC *value);
static  void  Parrot_Complex_i_divide_float(PARROT_INTERP, PMC *_self, FLOATVAL value);
static  void  Parrot_Complex_i_divide_int(PARROT_INTERP, PMC *_self, INTVAL value);
static  void Parrot_Complex_i_multiply(PARROT_INTERP, PMC *_self, PMC *value);
static  void  Parrot_Complex_i_multiply_float(PARROT_INTERP, PMC *_self, FLOATVAL value);
static  void  Parrot_Complex_i_multiply_int(PARROT_INTERP, PMC *_self, INTVAL value);
static  void  Parrot_Complex_i_neg(PARROT_INTERP, PMC *_self);
static  void Parrot_Complex_i_subtract(PARROT_INTERP, PMC *_self, PMC *value);
static  void  Parrot_Complex_i_subtract_float(PARROT_INTERP, PMC *_self, FLOATVAL value);
static  void  Parrot_Complex_i_subtract_int(PARROT_INTERP, PMC *_self, INTVAL value);
static  void  Parrot_Complex_init(PARROT_INTERP, PMC *_self);
static  void  Parrot_Complex_init_pmc(PARROT_INTERP, PMC *_self, PMC *initializer);
static  INTVAL Parrot_Complex_is_equal(PARROT_INTERP, PMC *_self, PMC *value);
static  PMC * Parrot_Complex_multiply(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest);
static  PMC  * Parrot_Complex_multiply_float(PARROT_INTERP, PMC *_self, FLOATVAL value, PMC *dest);
static  PMC  * Parrot_Complex_multiply_int(PARROT_INTERP, PMC *_self, INTVAL value, PMC *dest);
static  PMC  * Parrot_Complex_neg(PARROT_INTERP, PMC *_self, PMC *dest);
static  void  Parrot_Complex_set_integer_keyed(PARROT_INTERP, PMC *_self, PMC *key, INTVAL value);
static  void  Parrot_Complex_set_integer_keyed_str(PARROT_INTERP, PMC *_self, STRING *key, INTVAL value);
static  void  Parrot_Complex_set_integer_native(PARROT_INTERP, PMC *_self, INTVAL value);
static  void  Parrot_Complex_set_number_keyed(PARROT_INTERP, PMC *_self, PMC *key, FLOATVAL value);
static  void  Parrot_Complex_set_number_keyed_int(PARROT_INTERP, PMC *_self, INTVAL key, FLOATVAL v);
static  void  Parrot_Complex_set_number_keyed_str(PARROT_INTERP, PMC *_self, STRING *key, FLOATVAL value);
static  void  Parrot_Complex_set_number_native(PARROT_INTERP, PMC *_self, FLOATVAL value);
static  void  Parrot_Complex_set_pmc(PARROT_INTERP, PMC *_self, PMC *value);
static  void  Parrot_Complex_set_pmc_keyed(PARROT_INTERP, PMC *_self, PMC *key, PMC *value);
static  void  Parrot_Complex_set_pmc_keyed_str(PARROT_INTERP, PMC *_self, STRING *key, PMC *value);
static  void  Parrot_Complex_set_string_native(PARROT_INTERP, PMC *_self, STRING *value);
static  PMC * Parrot_Complex_subtract(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest);
static  PMC  * Parrot_Complex_subtract_float(PARROT_INTERP, PMC *_self, FLOATVAL value, PMC *dest);
static  PMC  * Parrot_Complex_subtract_int(PARROT_INTERP, PMC *_self, INTVAL value, PMC *dest);
static  void  Parrot_Complex_thaw(PARROT_INTERP, PMC *_self, PMC *visit);
static  PMC  * Parrot_Complex_multi_add_Complex_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest);
static  PMC  * Parrot_Complex_multi_add_DEFAULT_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest);
static  void  Parrot_Complex_multi_i_add_Complex(PARROT_INTERP, PMC *_self, PMC *value);
static  void  Parrot_Complex_multi_i_add_DEFAULT(PARROT_INTERP, PMC *_self, PMC *value);
static  PMC  * Parrot_Complex_multi_subtract_Complex_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest);
static  PMC  * Parrot_Complex_multi_subtract_DEFAULT_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest);
static  void  Parrot_Complex_multi_i_subtract_Complex(PARROT_INTERP, PMC *_self, PMC *value);
static  void  Parrot_Complex_multi_i_subtract_DEFAULT(PARROT_INTERP, PMC *_self, PMC *value);
static  PMC  * Parrot_Complex_multi_multiply_Complex_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest);
static  PMC  * Parrot_Complex_multi_multiply_DEFAULT_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest);
static  void  Parrot_Complex_multi_i_multiply_Complex(PARROT_INTERP, PMC *_self, PMC *value);
static  void  Parrot_Complex_multi_i_multiply_DEFAULT(PARROT_INTERP, PMC *_self, PMC *value);
static  PMC  * Parrot_Complex_multi_divide_Complex_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest);
static  PMC  * Parrot_Complex_multi_divide_DEFAULT_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest);
static  void  Parrot_Complex_multi_i_divide_Complex(PARROT_INTERP, PMC *_self, PMC *value);
static  void  Parrot_Complex_multi_i_divide_DEFAULT(PARROT_INTERP, PMC *_self, PMC *value);
static  INTVAL  Parrot_Complex_multi_is_equal_Complex(PARROT_INTERP, PMC *_self, PMC *value);
static  INTVAL  Parrot_Complex_multi_is_equal_DEFAULT(PARROT_INTERP, PMC *_self, PMC *value);
static  void Parrot_Complex_nci_ln(PARROT_INTERP, PMC *_self);
static  void Parrot_Complex_nci_exp(PARROT_INTERP, PMC *_self);
static  void Parrot_Complex_nci_sin(PARROT_INTERP, PMC *_self);
static  void Parrot_Complex_nci_cos(PARROT_INTERP, PMC *_self);
static  void Parrot_Complex_nci_tan(PARROT_INTERP, PMC *_self);
static  void Parrot_Complex_nci_cot(PARROT_INTERP, PMC *_self);
static  void Parrot_Complex_nci_sec(PARROT_INTERP, PMC *_self);
static  void Parrot_Complex_nci_csc(PARROT_INTERP, PMC *_self);
static  void Parrot_Complex_nci_asin(PARROT_INTERP, PMC *_self);
static  void Parrot_Complex_nci_acos(PARROT_INTERP, PMC *_self);
static  void Parrot_Complex_nci_atan(PARROT_INTERP, PMC *_self);
static  void Parrot_Complex_nci_acot(PARROT_INTERP, PMC *_self);
static  void Parrot_Complex_nci_acsc(PARROT_INTERP, PMC *_self);
static  void Parrot_Complex_nci_asec(PARROT_INTERP, PMC *_self);
static  void Parrot_Complex_nci_sinh(PARROT_INTERP, PMC *_self);
static  void Parrot_Complex_nci_cosh(PARROT_INTERP, PMC *_self);
static  void Parrot_Complex_nci_tanh(PARROT_INTERP, PMC *_self);
static  void Parrot_Complex_nci_coth(PARROT_INTERP, PMC *_self);
static  void Parrot_Complex_nci_csch(PARROT_INTERP, PMC *_self);
static  void Parrot_Complex_nci_sech(PARROT_INTERP, PMC *_self);
static  void Parrot_Complex_nci_asinh(PARROT_INTERP, PMC *_self);
static  void Parrot_Complex_nci_acosh(PARROT_INTERP, PMC *_self);
static  void Parrot_Complex_nci_atanh(PARROT_INTERP, PMC *_self);
static  void Parrot_Complex_nci_acoth(PARROT_INTERP, PMC *_self);
static  void Parrot_Complex_nci_acsch(PARROT_INTERP, PMC *_self);
static  void Parrot_Complex_nci_asech(PARROT_INTERP, PMC *_self);
static  void Parrot_Complex_nci_pow(PARROT_INTERP, PMC *_self);
static  void Parrot_Complex_nci_sqrt(PARROT_INTERP, PMC *_self);
void    Parrot_Complex_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_Complex_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_Complex_get_vtable(PARROT_INTERP);
void    Parrot_Complex_ro_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_Complex_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_Complex_ro_get_vtable(PARROT_INTERP);
static  PMC  *
Parrot_Complex_absolute(PARROT_INTERP, PMC *_self, PMC *dest)
{
#line 1250 "./src/pmc/complex.pmc"

    FLOATVAL re, im, d;
    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);
    d = sqrt(re*re + im*im);

    dest = Parrot_pmc_new(interp,
        Parrot_get_ctx_HLL_type(interp, enum_class_Float));

    VTABLE_set_number_native(interp, dest, d);
    return dest;
#line 450 "./src/pmc/complex.c"
}
static  PMC *
Parrot_Complex_add(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_Complex:
            return Parrot_Complex_multi_add_Complex_PMC(interp, _self, value, dest);
            break;

        default:
            if (type < enum_class_core_max)
                return Parrot_Complex_multi_add_DEFAULT_PMC(interp, _self, value, dest);
            else {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "add", "PPP->P", _self, value, dest, &retval);
                return retval;
            }
            break;

    }
}
static  PMC  *
Parrot_Complex_add_float(PARROT_INTERP, PMC *_self, FLOATVAL value, PMC *dest)
{
#line 757 "./src/pmc/complex.pmc"

    FLOATVAL re, im;
    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);
    SETATTR_Complex_re(interp, dest, re + value);
    SETATTR_Complex_im(interp, dest, im);

    return dest;
#line 490 "./src/pmc/complex.c"
}
static  PMC  *
Parrot_Complex_add_int(PARROT_INTERP, PMC *_self, INTVAL value, PMC *dest)
{
#line 753 "./src/pmc/complex.pmc"

    return VTABLE_add_float(interp, _self, (FLOATVAL)value, dest);
#line 498 "./src/pmc/complex.c"
}
static  PMC  *
Parrot_Complex_clone(PARROT_INTERP, PMC *_self)
{
#line 371 "./src/pmc/complex.pmc"

    PMC * const dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    FLOATVAL re, im;

    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);
    SETATTR_Complex_re(interp, dest, re);
    SETATTR_Complex_im(interp, dest, im);

    return dest;
#line 514 "./src/pmc/complex.c"
}
static  PMC *
Parrot_Complex_divide(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_Complex:
            return Parrot_Complex_multi_divide_Complex_PMC(interp, _self, value, dest);
            break;

        default:
            if (type < enum_class_core_max)
                return Parrot_Complex_multi_divide_DEFAULT_PMC(interp, _self, value, dest);
            else {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "divide", "PPP->P", _self, value, dest, &retval);
                return retval;
            }
            break;

    }
}
static  PMC  *
Parrot_Complex_divide_float(PARROT_INTERP, PMC *_self, FLOATVAL value, PMC *dest)
{
#line 1087 "./src/pmc/complex.pmc"

    FLOATVAL re, im;
    float_check_divide_zero(interp, value);
    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);

    SETATTR_Complex_re(interp, dest, re / value);
    SETATTR_Complex_im(interp, dest, im / value);

    return dest;
#line 556 "./src/pmc/complex.c"
}
static  PMC  *
Parrot_Complex_divide_int(PARROT_INTERP, PMC *_self, INTVAL value, PMC *dest)
{
#line 1073 "./src/pmc/complex.pmc"

    FLOATVAL re, im;
    int_check_divide_zero(interp, value);
    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);

    SETATTR_Complex_re(interp, dest, re / value);
    SETATTR_Complex_im(interp, dest, im / value);

    return dest;
#line 574 "./src/pmc/complex.c"
}
static  void 
Parrot_Complex_freeze(PARROT_INTERP, PMC *_self, PMC *visit)
{
#line 395 "./src/pmc/complex.pmc"

    FLOATVAL re, im;

    interp->vtables[enum_class_default]->freeze(interp, _self, visit);

    GETATTR_Complex_re(interp, _self, re);
    VTABLE_push_float(interp, visit, re);

    GETATTR_Complex_im(interp, _self, im);
    VTABLE_push_float(interp, visit, im);
#line 590 "./src/pmc/complex.c"
}
static  INTVAL 
Parrot_Complex_get_bool(PARROT_INTERP, PMC *_self)
{
#line 460 "./src/pmc/complex.pmc"

    FLOATVAL re, im;
    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);
    return !(FLOAT_IS_ZERO(re) && FLOAT_IS_ZERO(im));
#line 601 "./src/pmc/complex.c"
}
static  INTVAL 
Parrot_Complex_get_integer(PARROT_INTERP, PMC *_self)
{
#line 441 "./src/pmc/complex.pmc"

    const FLOATVAL f = VTABLE_get_number(interp, _self);
    return (INTVAL)f;
#line 610 "./src/pmc/complex.c"
}
static  INTVAL 
Parrot_Complex_get_integer_keyed(PARROT_INTERP, PMC *_self, PMC *key)
{
#line 487 "./src/pmc/complex.pmc"

    STRING * const s = VTABLE_get_string(interp, key);
    return VTABLE_get_integer_keyed_str(interp, _self, s);
#line 619 "./src/pmc/complex.c"
}
static  INTVAL 
Parrot_Complex_get_integer_keyed_str(PARROT_INTERP, PMC *_self, STRING *key)
{
#line 492 "./src/pmc/complex.pmc"

    const FLOATVAL f = VTABLE_get_number_keyed_str(interp, _self, key);
    return (INTVAL)f;
#line 628 "./src/pmc/complex.c"
}
static  FLOATVAL 
Parrot_Complex_get_number(PARROT_INTERP, PMC *_self)
{
#line 446 "./src/pmc/complex.pmc"

    FLOATVAL re, im;
    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);
    return sqrt(re * re + im * im);
#line 639 "./src/pmc/complex.c"
}
static  FLOATVAL 
Parrot_Complex_get_number_keyed(PARROT_INTERP, PMC *_self, PMC *key)
{
#line 497 "./src/pmc/complex.pmc"

    STRING * const s = VTABLE_get_string(interp, key);
    return VTABLE_get_number_keyed_str(interp, _self, s);
#line 648 "./src/pmc/complex.c"
}
static  FLOATVAL 
Parrot_Complex_get_number_keyed_int(PARROT_INTERP, PMC *_self, INTVAL key)
{
#line 568 "./src/pmc/complex.pmc"

    FLOATVAL f;
    switch (key) {
      case 0:
        GETATTR_Complex_re(interp, _self, f);
        break;
      case 1:
        GETATTR_Complex_im(interp, _self, f);
        break;
      default:
        Parrot_ex_throw_from_c_args(interp, NULL,
                EXCEPTION_INVALID_OPERATION, "Complex: key must be 0 or 1");
    }
    return f;
#line 668 "./src/pmc/complex.c"
}
static  FLOATVAL 
Parrot_Complex_get_number_keyed_str(PARROT_INTERP, PMC *_self, STRING *key)
{
#line 502 "./src/pmc/complex.pmc"

    FLOATVAL value;
    if (Parrot_str_equal(interp, key, CONST_STRING(interp, "real"))) {
        GETATTR_Complex_re(interp, _self, value);
    }
    else if (Parrot_str_equal(interp, key, CONST_STRING(interp, "imag"))) {
        GETATTR_Complex_im(interp, _self, value);
    }
    else
        Parrot_ex_throw_from_c_args(interp, NULL,
            EXCEPTION_INVALID_OPERATION, "Complex: key is neither 'real' or 'imag'");
    return value;
#line 686 "./src/pmc/complex.c"
}
static  PMC  *
Parrot_Complex_get_pmc_keyed(PARROT_INTERP, PMC *_self, PMC *key)
{
#line 516 "./src/pmc/complex.pmc"

    if (VTABLE_isa(interp, key, CONST_STRING(interp, "Integer"))) {
        const INTVAL i = VTABLE_get_integer(interp, key);
        return VTABLE_get_pmc_keyed_int(interp, _self, i);
    }
    else {
        STRING * const s = VTABLE_get_string(interp, key);
        return VTABLE_get_pmc_keyed_str(interp, _self, s);
    }
#line 701 "./src/pmc/complex.c"
}
static  PMC  *
Parrot_Complex_get_pmc_keyed_int(PARROT_INTERP, PMC *_self, INTVAL key)
{
#line 544 "./src/pmc/complex.pmc"

    PMC * const    ret = Parrot_pmc_new(interp, enum_class_Float);
    const FLOATVAL val = VTABLE_get_number_keyed_int(interp, _self, key);
    VTABLE_set_number_native(interp, ret, val);
    return ret;
#line 712 "./src/pmc/complex.c"
}
static  PMC  *
Parrot_Complex_get_pmc_keyed_str(PARROT_INTERP, PMC *_self, STRING *key)
{
#line 527 "./src/pmc/complex.pmc"

    PMC * const    ret = Parrot_pmc_new(interp, enum_class_Float);
    const FLOATVAL val = VTABLE_get_number_keyed_str(interp, _self, key);
    VTABLE_set_number_native(interp, ret, val);
    return ret;
#line 723 "./src/pmc/complex.c"
}
static  STRING  *
Parrot_Complex_get_string(PARROT_INTERP, PMC *_self)
{
#line 453 "./src/pmc/complex.pmc"

    FLOATVAL re, im;
    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);
    return Parrot_sprintf_c(interp, "%vg%+vgi", re, im);
#line 734 "./src/pmc/complex.c"
}
static  void 
Parrot_Complex_i_absolute(PARROT_INTERP, PMC *_self)
{
#line 1263 "./src/pmc/complex.pmc"

    FLOATVAL re, im, d;
    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);
    d = sqrt(re*re + im*im);
    Parrot_pmc_reuse(interp, _self, enum_class_Float, 0);
    VTABLE_set_number_native(interp, _self, d);
#line 747 "./src/pmc/complex.c"
}
static  void
Parrot_Complex_i_add(PARROT_INTERP, PMC *_self, PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_Complex:
            Parrot_Complex_multi_i_add_Complex(interp, _self, value);
            break;

        default:
            if (type < enum_class_core_max)
                Parrot_Complex_multi_i_add_DEFAULT(interp, _self, value);
            else {
                
                Parrot_mmd_multi_dispatch_from_c_args(interp, "i_add", "PP->", _self, value);
                return;
            }
            break;

    }
}
static  void 
Parrot_Complex_i_add_float(PARROT_INTERP, PMC *_self, FLOATVAL value)
{
#line 793 "./src/pmc/complex.pmc"

    FLOATVAL re;

    GETATTR_Complex_re(interp, _self, re);
    SETATTR_Complex_re(interp, _self, re + value);
#line 782 "./src/pmc/complex.c"
}
static  void 
Parrot_Complex_i_add_int(PARROT_INTERP, PMC *_self, INTVAL value)
{
#line 789 "./src/pmc/complex.pmc"

    VTABLE_i_add_float(interp, _self, (FLOATVAL)value);
#line 790 "./src/pmc/complex.c"
}
static  void
Parrot_Complex_i_divide(PARROT_INTERP, PMC *_self, PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_Complex:
            Parrot_Complex_multi_i_divide_Complex(interp, _self, value);
            break;

        default:
            if (type < enum_class_core_max)
                Parrot_Complex_multi_i_divide_DEFAULT(interp, _self, value);
            else {
                
                Parrot_mmd_multi_dispatch_from_c_args(interp, "i_divide", "PP->", _self, value);
                return;
            }
            break;

    }
}
static  void 
Parrot_Complex_i_divide_float(PARROT_INTERP, PMC *_self, FLOATVAL value)
{
#line 1152 "./src/pmc/complex.pmc"

    FLOATVAL re, im;
    float_check_divide_zero(interp, value);

    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);

    SETATTR_Complex_re(interp, _self, re / value);
    SETATTR_Complex_im(interp, _self, im / value);
#line 829 "./src/pmc/complex.c"
}
static  void 
Parrot_Complex_i_divide_int(PARROT_INTERP, PMC *_self, INTVAL value)
{
#line 1141 "./src/pmc/complex.pmc"

    FLOATVAL re, im;
    int_check_divide_zero(interp, value);

    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);

    SETATTR_Complex_re(interp, _self, re / value);
    SETATTR_Complex_im(interp, _self, im / value);
#line 844 "./src/pmc/complex.c"
}
static  void
Parrot_Complex_i_multiply(PARROT_INTERP, PMC *_self, PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_Complex:
            Parrot_Complex_multi_i_multiply_Complex(interp, _self, value);
            break;

        default:
            if (type < enum_class_core_max)
                Parrot_Complex_multi_i_multiply_DEFAULT(interp, _self, value);
            else {
                
                Parrot_mmd_multi_dispatch_from_c_args(interp, "i_multiply", "PP->", _self, value);
                return;
            }
            break;

    }
}
static  void 
Parrot_Complex_i_multiply_float(PARROT_INTERP, PMC *_self, FLOATVAL value)
{
#line 988 "./src/pmc/complex.pmc"

    FLOATVAL re, im;

    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);
    SETATTR_Complex_re(interp, _self, re * value);
    SETATTR_Complex_im(interp, _self, im * value);
#line 881 "./src/pmc/complex.c"
}
static  void 
Parrot_Complex_i_multiply_int(PARROT_INTERP, PMC *_self, INTVAL value)
{
#line 979 "./src/pmc/complex.pmc"

    FLOATVAL re, im;

    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);
    SETATTR_Complex_re(interp, _self, re * value);
    SETATTR_Complex_im(interp, _self, im * value);
#line 894 "./src/pmc/complex.c"
}
static  void 
Parrot_Complex_i_neg(PARROT_INTERP, PMC *_self)
{
#line 1188 "./src/pmc/complex.pmc"

    FLOATVAL re, im;
    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);
    SETATTR_Complex_re(interp, _self, -re);
    SETATTR_Complex_im(interp, _self, -im);
#line 906 "./src/pmc/complex.c"
}
static  void
Parrot_Complex_i_subtract(PARROT_INTERP, PMC *_self, PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_Complex:
            Parrot_Complex_multi_i_subtract_Complex(interp, _self, value);
            break;

        default:
            if (type < enum_class_core_max)
                Parrot_Complex_multi_i_subtract_DEFAULT(interp, _self, value);
            else {
                
                Parrot_mmd_multi_dispatch_from_c_args(interp, "i_subtract", "PP->", _self, value);
                return;
            }
            break;

    }
}
static  void 
Parrot_Complex_i_subtract_float(PARROT_INTERP, PMC *_self, FLOATVAL value)
{
#line 882 "./src/pmc/complex.pmc"

    FLOATVAL re;

    GETATTR_Complex_re(interp, _self, re);
    SETATTR_Complex_re(interp, _self, re - value);
#line 941 "./src/pmc/complex.c"
}
static  void 
Parrot_Complex_i_subtract_int(PARROT_INTERP, PMC *_self, INTVAL value)
{
#line 878 "./src/pmc/complex.pmc"

    VTABLE_i_subtract_float(interp, _self, (FLOATVAL) value);
#line 949 "./src/pmc/complex.c"
}
static  void 
Parrot_Complex_init(PARROT_INTERP, PMC *_self)
{
#line 334 "./src/pmc/complex.pmc"

    SETATTR_Complex_re(interp, _self, 0.0);
    SETATTR_Complex_im(interp, _self, 0.0);
#line 958 "./src/pmc/complex.c"
}
static  void 
Parrot_Complex_init_pmc(PARROT_INTERP, PMC *_self, PMC *initializer)
{
#line 339 "./src/pmc/complex.pmc"

    const INTVAL arg_type = VTABLE_type(interp, initializer);
    VTABLE_init(interp, _self);
    switch (arg_type) {
      case enum_class_String:
        VTABLE_set_string_native(interp, _self, VTABLE_get_string(interp, initializer));
        break;
      case enum_class_FixedFloatArray:
      case enum_class_ResizableFloatArray:
      case enum_class_FixedIntegerArray:
      case enum_class_ResizableIntegerArray:
        if (VTABLE_get_integer(interp, initializer) == 2) {
            const FLOATVAL re = VTABLE_get_number_keyed_int(interp, initializer, 0);
            const FLOATVAL im = VTABLE_get_number_keyed_int(interp, initializer, 1);
            SETATTR_Complex_re(interp, _self, re);
            SETATTR_Complex_im(interp, _self, im);
            break;
        }
        /* else let it fall to default */
      default:
        if (VTABLE_isa(interp, initializer, CONST_STRING(interp, "String"))) {
            STRING * const s = VTABLE_get_string(interp, initializer);
            VTABLE_set_string_native(interp, _self, s);
        }
        else {
            Parrot_ex_throw_from_c_args(interp, NULL,
                    EXCEPTION_INVALID_OPERATION,
                    "Invalid Complex initializer");
        }
    }
#line 994 "./src/pmc/complex.c"
}
static  INTVAL
Parrot_Complex_is_equal(PARROT_INTERP, PMC *_self, PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_Complex:
            return Parrot_Complex_multi_is_equal_Complex(interp, _self, value);
            break;

        default:
            if (type < enum_class_core_max)
                return Parrot_Complex_multi_is_equal_DEFAULT(interp, _self, value);
            else {
                INTVAL retval;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "is_equal", "PP->I", _self, value, &retval);
                return retval;
            }
            break;

    }
}
static  PMC *
Parrot_Complex_multiply(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_Complex:
            return Parrot_Complex_multi_multiply_Complex_PMC(interp, _self, value, dest);
            break;

        default:
            if (type < enum_class_core_max)
                return Parrot_Complex_multi_multiply_DEFAULT_PMC(interp, _self, value, dest);
            else {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "multiply", "PPP->P", _self, value, dest, &retval);
                return retval;
            }
            break;

    }
}
static  PMC  *
Parrot_Complex_multiply_float(PARROT_INTERP, PMC *_self, FLOATVAL value, PMC *dest)
{
#line 947 "./src/pmc/complex.pmc"

    FLOATVAL re, im;
    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);
    SETATTR_Complex_re(interp, dest, re * value);
    SETATTR_Complex_im(interp, dest, im * value);

    return dest;
#line 1058 "./src/pmc/complex.c"
}
static  PMC  *
Parrot_Complex_multiply_int(PARROT_INTERP, PMC *_self, INTVAL value, PMC *dest)
{
#line 943 "./src/pmc/complex.pmc"

    return VTABLE_multiply_float(interp, _self, (FLOATVAL) value, dest);
#line 1066 "./src/pmc/complex.c"
}
static  PMC  *
Parrot_Complex_neg(PARROT_INTERP, PMC *_self, PMC *dest)
{
#line 1175 "./src/pmc/complex.pmc"

    FLOATVAL re, im;
    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);

    SETATTR_Complex_re(interp, dest, -re);
    SETATTR_Complex_im(interp, dest, -im);

    return dest;
#line 1083 "./src/pmc/complex.c"
}
static  void 
Parrot_Complex_set_integer_keyed(PARROT_INTERP, PMC *_self, PMC *key, INTVAL value)
{
#line 670 "./src/pmc/complex.pmc"

    VTABLE_set_number_keyed(interp, _self, key, (FLOATVAL)value);
#line 1091 "./src/pmc/complex.c"
}
static  void 
Parrot_Complex_set_integer_keyed_str(PARROT_INTERP, PMC *_self, STRING *key, INTVAL value)
{
#line 674 "./src/pmc/complex.pmc"

    VTABLE_set_number_keyed_str(interp, _self, key, (FLOATVAL)value);
#line 1099 "./src/pmc/complex.c"
}
static  void 
Parrot_Complex_set_integer_native(PARROT_INTERP, PMC *_self, INTVAL value)
{
#line 640 "./src/pmc/complex.pmc"

    VTABLE_set_number_native(interp, _self, (FLOATVAL)value);
#line 1107 "./src/pmc/complex.c"
}
static  void 
Parrot_Complex_set_number_keyed(PARROT_INTERP, PMC *_self, PMC *key, FLOATVAL value)
{
#line 678 "./src/pmc/complex.pmc"

    if (VTABLE_isa(interp, key, CONST_STRING(interp, "Integer"))) {
        const INTVAL i = VTABLE_get_integer(interp, key);
        VTABLE_set_number_keyed_int(interp, _self, i, value);
    }
    else {
        STRING *s = VTABLE_get_string(interp, key);
        VTABLE_set_number_keyed_str(interp, _self, s, value);
    }
#line 1122 "./src/pmc/complex.c"
}
static  void 
Parrot_Complex_set_number_keyed_int(PARROT_INTERP, PMC *_self, INTVAL key, FLOATVAL v)
{
#line 584 "./src/pmc/complex.pmc"

    switch (key) {
      case 0:
        SETATTR_Complex_re(interp, _self, v);
        break;
      case 1:
        SETATTR_Complex_im(interp, _self, v);
        break;
      default:
        Parrot_ex_throw_from_c_args(interp, NULL,
                EXCEPTION_INVALID_OPERATION, "Complex: key must be 0 or 1");
    }
#line 1140 "./src/pmc/complex.c"
}
static  void 
Parrot_Complex_set_number_keyed_str(PARROT_INTERP, PMC *_self, STRING *key, FLOATVAL value)
{
#line 689 "./src/pmc/complex.pmc"

    if (Parrot_str_equal(interp, key, CONST_STRING(interp, "real"))) {
        SETATTR_Complex_re(interp, _self, value);
    }
    else if (Parrot_str_equal(interp, key, CONST_STRING(interp, "imag"))) {
        SETATTR_Complex_im(interp, _self, value);
    }
    else
        Parrot_ex_throw_from_c_args(interp, NULL,
            EXCEPTION_INVALID_OPERATION, "Complex: key is neither 'real' or 'imag'");
#line 1156 "./src/pmc/complex.c"
}
static  void 
Parrot_Complex_set_number_native(PARROT_INTERP, PMC *_self, FLOATVAL value)
{
#line 644 "./src/pmc/complex.pmc"

    SETATTR_Complex_re(interp, _self, value);
    SETATTR_Complex_im(interp, _self, 0.0);
#line 1165 "./src/pmc/complex.c"
}
static  void 
Parrot_Complex_set_pmc(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 628 "./src/pmc/complex.pmc"

    if (VTABLE_isa(interp, value, CONST_STRING(interp, "Complex"))) {
        FLOATVAL re, im;
        GETATTR_Complex_re(interp, value, re);
        GETATTR_Complex_im(interp, value, im);
        SETATTR_Complex_re(interp, _self, re);
        SETATTR_Complex_im(interp, _self, im);
    }
    else
        VTABLE_set_string_native(interp, _self, VTABLE_get_string(interp, value));
#line 1181 "./src/pmc/complex.c"
}
static  void 
Parrot_Complex_set_pmc_keyed(PARROT_INTERP, PMC *_self, PMC *key, PMC *value)
{
#line 701 "./src/pmc/complex.pmc"

    const FLOATVAL f = VTABLE_get_number(interp, value);
    VTABLE_set_number_keyed(interp, _self, key, f);
#line 1190 "./src/pmc/complex.c"
}
static  void 
Parrot_Complex_set_pmc_keyed_str(PARROT_INTERP, PMC *_self, STRING *key, PMC *value)
{
#line 706 "./src/pmc/complex.pmc"

    const FLOATVAL f = VTABLE_get_number(interp, value);
    VTABLE_set_number_keyed_str(interp, _self, key, f);
#line 1199 "./src/pmc/complex.c"
}
static  void 
Parrot_Complex_set_string_native(PARROT_INTERP, PMC *_self, STRING *value)
{
#line 621 "./src/pmc/complex.pmc"

    FLOATVAL re, im;
    complex_parse_string(interp, &re, &im, value);
    SETATTR_Complex_re(interp, _self, re);
    SETATTR_Complex_im(interp, _self, im);
#line 1210 "./src/pmc/complex.c"
}
static  PMC *
Parrot_Complex_subtract(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_Complex:
            return Parrot_Complex_multi_subtract_Complex_PMC(interp, _self, value, dest);
            break;

        default:
            if (type < enum_class_core_max)
                return Parrot_Complex_multi_subtract_DEFAULT_PMC(interp, _self, value, dest);
            else {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "subtract", "PPP->P", _self, value, dest, &retval);
                return retval;
            }
            break;

    }
}
static  PMC  *
Parrot_Complex_subtract_float(PARROT_INTERP, PMC *_self, FLOATVAL value, PMC *dest)
{
#line 846 "./src/pmc/complex.pmc"

    FLOATVAL re, im;
    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);
    SETATTR_Complex_re(interp, dest, re - value);
    SETATTR_Complex_im(interp, dest, im);

    return dest;
#line 1250 "./src/pmc/complex.c"
}
static  PMC  *
Parrot_Complex_subtract_int(PARROT_INTERP, PMC *_self, INTVAL value, PMC *dest)
{
#line 842 "./src/pmc/complex.pmc"

    return VTABLE_subtract_float(interp, _self, (FLOATVAL)value, dest);
#line 1258 "./src/pmc/complex.c"
}
static  void 
Parrot_Complex_thaw(PARROT_INTERP, PMC *_self, PMC *visit)
{
#line 407 "./src/pmc/complex.pmc"

    FLOATVAL re, im;

    interp->vtables[enum_class_default]->thaw(interp, _self, visit);

    re = VTABLE_shift_float(interp, visit);
    SETATTR_Complex_re(interp, _self, re);

    im = VTABLE_shift_float(interp, visit);
    SETATTR_Complex_im(interp, _self, im);
#line 1274 "./src/pmc/complex.c"
}
static  PMC  *
Parrot_Complex_multi_add_Complex_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest)
{
#line 725 "./src/pmc/complex.pmc"

    FLOATVAL self_re, self_im, val_re, val_im;
    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    GETATTR_Complex_re(interp, _self, self_re);
    GETATTR_Complex_im(interp, _self, self_im);

    GETATTR_Complex_re(interp, value, val_re);
    GETATTR_Complex_im(interp, value, val_im);

    SETATTR_Complex_re(interp, dest, self_re + val_re);
    SETATTR_Complex_im(interp, dest, self_im + val_im);

    return dest;
#line 1294 "./src/pmc/complex.c"
}
static  PMC  *
Parrot_Complex_multi_add_DEFAULT_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest)
{
#line 741 "./src/pmc/complex.pmc"

    FLOATVAL re, im;
    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);
    SETATTR_Complex_re(interp, dest, re + VTABLE_get_number(interp, value));
    SETATTR_Complex_im(interp, dest, im);

    return dest;
#line 1310 "./src/pmc/complex.c"
}
static  void 
Parrot_Complex_multi_i_add_Complex(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 769 "./src/pmc/complex.pmc"

    FLOATVAL self_re, self_im, val_re, val_im;

    GETATTR_Complex_re(interp, _self, self_re);
    GETATTR_Complex_im(interp, _self, self_im);

    GETATTR_Complex_re(interp, value, val_re);
    GETATTR_Complex_im(interp, value, val_im);

    SETATTR_Complex_re(interp, _self, self_re + val_re);
    SETATTR_Complex_im(interp, _self, self_im + val_im);
#line 1327 "./src/pmc/complex.c"
}
static  void 
Parrot_Complex_multi_i_add_DEFAULT(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 782 "./src/pmc/complex.pmc"

    FLOATVAL re;

    GETATTR_Complex_re(interp, _self, re);
    SETATTR_Complex_re(interp, _self, re + VTABLE_get_number(interp, value));
#line 1338 "./src/pmc/complex.c"
}
static  PMC  *
Parrot_Complex_multi_subtract_Complex_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest)
{
#line 814 "./src/pmc/complex.pmc"

    FLOATVAL self_re, self_im, val_re, val_im;
    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    GETATTR_Complex_re(interp, _self, self_re);
    GETATTR_Complex_im(interp, _self, self_im);

    GETATTR_Complex_re(interp, value, val_re);
    GETATTR_Complex_im(interp, value, val_im);

    SETATTR_Complex_re(interp, dest, self_re - val_re);
    SETATTR_Complex_im(interp, dest, self_im - val_im);

    return dest;
#line 1358 "./src/pmc/complex.c"
}
static  PMC  *
Parrot_Complex_multi_subtract_DEFAULT_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest)
{
#line 830 "./src/pmc/complex.pmc"

    FLOATVAL re, im;
    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);
    SETATTR_Complex_re(interp, dest, re - VTABLE_get_number(interp, value));
    SETATTR_Complex_im(interp, dest, im);

    return dest;
#line 1374 "./src/pmc/complex.c"
}
static  void 
Parrot_Complex_multi_i_subtract_Complex(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 858 "./src/pmc/complex.pmc"

    FLOATVAL self_re, self_im, val_re, val_im;

    GETATTR_Complex_re(interp, _self, self_re);
    GETATTR_Complex_im(interp, _self, self_im);

    GETATTR_Complex_re(interp, value, val_re);
    GETATTR_Complex_im(interp, value, val_im);

    SETATTR_Complex_re(interp, _self, self_re - val_re);
    SETATTR_Complex_im(interp, _self, self_im - val_im);
#line 1391 "./src/pmc/complex.c"
}
static  void 
Parrot_Complex_multi_i_subtract_DEFAULT(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 871 "./src/pmc/complex.pmc"

    FLOATVAL re;

    GETATTR_Complex_re(interp, _self, re);
    SETATTR_Complex_re(interp, _self, re - VTABLE_get_number(interp, value));
#line 1402 "./src/pmc/complex.c"
}
static  PMC  *
Parrot_Complex_multi_multiply_Complex_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest)
{
#line 916 "./src/pmc/complex.pmc"

    FLOATVAL a, b, c, d;

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    GETATTR_Complex_re(interp, _self, a);
    GETATTR_Complex_im(interp, _self, b);
    GETATTR_Complex_re(interp, value, c);
    GETATTR_Complex_im(interp, value, d);
    SETATTR_Complex_re(interp, dest, a * c - b * d);
    SETATTR_Complex_im(interp, dest, a * d + b * c);

    return dest;
#line 1421 "./src/pmc/complex.c"
}
static  PMC  *
Parrot_Complex_multi_multiply_DEFAULT_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest)
{
#line 931 "./src/pmc/complex.pmc"

    FLOATVAL re, im;
    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);
    SETATTR_Complex_re(interp, dest, re * VTABLE_get_number(interp, value));
    SETATTR_Complex_im(interp, dest, im * VTABLE_get_number(interp, value));

    return dest;
#line 1437 "./src/pmc/complex.c"
}
static  void 
Parrot_Complex_multi_i_multiply_Complex(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 959 "./src/pmc/complex.pmc"

    FLOATVAL a, b, c, d;

    GETATTR_Complex_re(interp, _self, a);
    GETATTR_Complex_im(interp, _self, b);
    GETATTR_Complex_re(interp, value, c);
    GETATTR_Complex_im(interp, value, d);
    SETATTR_Complex_re(interp, _self, a * c - b * d);
    SETATTR_Complex_im(interp, _self, a * d + b * c);
#line 1452 "./src/pmc/complex.c"
}
static  void 
Parrot_Complex_multi_i_multiply_DEFAULT(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 970 "./src/pmc/complex.pmc"

    FLOATVAL re, im;

    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);
    SETATTR_Complex_re(interp, _self, re * VTABLE_get_number(interp, value));
    SETATTR_Complex_im(interp, _self, im * VTABLE_get_number(interp, value));
#line 1465 "./src/pmc/complex.c"
}
static  PMC  *
Parrot_Complex_multi_divide_Complex_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest)
{
#line 1027 "./src/pmc/complex.pmc"

    FLOATVAL mod, re, im;
    FLOATVAL self_re, self_im, val_re, val_im;

    complex_check_divide_zero(interp, value);
    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    GETATTR_Complex_re(interp, _self, self_re);
    GETATTR_Complex_im(interp, _self, self_im);
    GETATTR_Complex_re(interp, value, val_re);
    GETATTR_Complex_im(interp, value, val_im);

    /* a little speed optimisation: cache an intermediate number;
        I'm not sure the compiler does this */

    if (self_im == 0.0 && val_im == 0.0) {
        re = self_re / val_re;
        im = 0.0;
    }
    else {
        mod = (val_re * val_re + val_im * val_im);
        re  = (self_re * val_re + self_im * val_im) / mod;
        im  = (self_im * val_re - self_re * val_im) / mod;
    }

    SETATTR_Complex_re(interp, dest, re);
    SETATTR_Complex_im(interp, dest, im);

    return dest;
#line 1500 "./src/pmc/complex.c"
}
static  PMC  *
Parrot_Complex_multi_divide_DEFAULT_PMC(PARROT_INTERP, PMC *_self, PMC *value, PMC *dest)
{
#line 1058 "./src/pmc/complex.pmc"

    FLOATVAL re, im;
    const FLOATVAL d = VTABLE_get_number(interp, value);
    float_check_divide_zero(interp, d);
    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);

    SETATTR_Complex_re(interp, dest, re / d);
    SETATTR_Complex_im(interp, dest, im / d);

    return dest;
#line 1519 "./src/pmc/complex.c"
}
static  void 
Parrot_Complex_multi_i_divide_Complex(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 1101 "./src/pmc/complex.pmc"

    FLOATVAL re, im;
    FLOATVAL self_re, self_im, val_re, val_im;

    complex_check_divide_zero(interp, value);

    GETATTR_Complex_re(interp, _self, self_re);
    GETATTR_Complex_im(interp, _self, self_im);
    GETATTR_Complex_re(interp, value, val_re);
    GETATTR_Complex_im(interp, value, val_im);

    if (self_im == 0.0 && val_im == 0.0) {
        re = self_re / val_re;
        im = 0.0;
    }
    else {
        /* a little speed optimisation: cache an intermediate number;
           I'm not sure the compiler does this */
        const FLOATVAL mod = (val_re * val_re + val_im * val_im);
        re  = (self_re * val_re + self_im * val_im) / mod;
        im  = (self_im * val_re - self_re * val_im) / mod;
    }

    SETATTR_Complex_re(interp, _self, re);
    SETATTR_Complex_im(interp, _self, im);

#line 1551 "./src/pmc/complex.c"
}
static  void 
Parrot_Complex_multi_i_divide_DEFAULT(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 1129 "./src/pmc/complex.pmc"

    FLOATVAL re, im;
    const FLOATVAL d = VTABLE_get_number(interp, value);
    float_check_divide_zero(interp, d);

    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);

    SETATTR_Complex_re(interp, _self, re / d);
    SETATTR_Complex_im(interp, _self, im / d);
#line 1567 "./src/pmc/complex.c"
}
static  INTVAL 
Parrot_Complex_multi_is_equal_Complex(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 1206 "./src/pmc/complex.pmc"

    FLOATVAL self_re, self_im, val_re, val_im;
    GETATTR_Complex_re(interp, _self, self_re);
    GETATTR_Complex_im(interp, _self, self_im);
    GETATTR_Complex_re(interp, value, val_re);
    GETATTR_Complex_im(interp, value, val_im);
    return (INTVAL)(self_re == val_re && self_im == val_im);
#line 1580 "./src/pmc/complex.c"
}
static  INTVAL 
Parrot_Complex_multi_is_equal_DEFAULT(PARROT_INTERP, PMC *_self, PMC *value)
{
#line 1215 "./src/pmc/complex.pmc"

    FLOATVAL re, im;
    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);

    if (im != 0.0)
        return (INTVAL)0;

    return (re == VTABLE_get_number(interp, value));
#line 1595 "./src/pmc/complex.c"
}
static  void
Parrot_Complex_nci_ln(PARROT_INTERP, PMC *_self)
{
#line 422 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 1607 "./src/pmc/complex.pmc"
PMC* _self;

#line 430 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
#line 434 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 1293 "./src/pmc/complex.pmc"

    PMC * const d  = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    FLOATVAL re, im, result_re, result_im;
    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);

    /* This is necessary for atan2 to behave */
    if (im == -0.0)
        im = 0.0;

    result_re = log(sqrt(re*re + im*im));
    if (re == 0.0 && im == 0.0) /* atan2(0, 0) not portable */
        result_im = 0.0;
    else
        result_im = atan2(im, re);

    SETATTR_Complex_re(interp, d, result_re);
    SETATTR_Complex_im(interp, d, result_im);

    #line 260 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *d */
#line 267 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "P", (PMC*)d);
    return;
    /*END RETURN PMC *d */
    }
#line 1312 "./src/pmc/complex.pmc"

#line 441 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 1651 "./src/pmc/complex.c"
}
static  void
Parrot_Complex_nci_exp(PARROT_INTERP, PMC *_self)
{
#line 422 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 1663 "./src/pmc/complex.pmc"
PMC* _self;

#line 430 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
#line 434 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 1327 "./src/pmc/complex.pmc"

    PMC * const d  = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    FLOATVAL re, im, f;
    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);

    f  = exp(re);

    SETATTR_Complex_re(interp, d, f * cos(im));

    /* If only sin(pi) worked. */
    if (im == 4.0 * atan(1.0)) {
        SETATTR_Complex_im(interp, d, 0.0);
    }
    else {
        SETATTR_Complex_im(interp, d, f * sin(im));
    }

    #line 260 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *d */
#line 267 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "P", (PMC*)d);
    return;
    /*END RETURN PMC *d */
    }
#line 1345 "./src/pmc/complex.pmc"

#line 441 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 1706 "./src/pmc/complex.c"
}
static  void
Parrot_Complex_nci_sin(PARROT_INTERP, PMC *_self)
{
#line 422 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 1718 "./src/pmc/complex.pmc"
PMC* _self;

#line 430 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
#line 434 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 1381 "./src/pmc/complex.pmc"

    PMC * const d = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    FLOATVAL re, im, result_re, result_im;
    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);

    if (FLOAT_IS_ZERO(im)) {
        result_re = sin(re);
        result_im = 0.0;
    }
    else if (FLOAT_IS_ZERO(re)) {
        result_re = 0.0;
        result_im = sinh(im);
    }
    else {
        result_re = sin(re) * cosh(im);

        if (im == -0.0)
            result_im = 0.0;
        else
            result_im = cos(re) * sinh(im);

    }

    SETATTR_Complex_re(interp, d, result_re);
    SETATTR_Complex_im(interp, d, result_im);

    #line 260 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *d */
#line 267 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "P", (PMC*)d);
    return;
    /*END RETURN PMC *d */
    }
#line 1408 "./src/pmc/complex.pmc"

#line 441 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 1770 "./src/pmc/complex.c"
}
static  void
Parrot_Complex_nci_cos(PARROT_INTERP, PMC *_self)
{
#line 422 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 1782 "./src/pmc/complex.pmc"
PMC* _self;

#line 430 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
#line 434 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 1411 "./src/pmc/complex.pmc"

    PMC * const d  = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    FLOATVAL re, im, result_re, result_im;
    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);

    if (FLOAT_IS_ZERO(re)) {
        result_re = cosh(im);
        result_im = 0.0;
    }
    else if (FLOAT_IS_ZERO(im)) {
        result_re = cos(re);
        result_im = 0.0;
    }
    else {
        result_re = cos(re) * cosh(im);
        result_im = -1.0 * sin(re) * sinh(im);
    }

    SETATTR_Complex_re(interp, d, result_re);
    SETATTR_Complex_im(interp, d, result_im);

    #line 260 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *d */
#line 267 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "P", (PMC*)d);
    return;
    /*END RETURN PMC *d */
    }
#line 1433 "./src/pmc/complex.pmc"

#line 441 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 1829 "./src/pmc/complex.c"
}
static  void
Parrot_Complex_nci_tan(PARROT_INTERP, PMC *_self)
{
#line 422 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 1841 "./src/pmc/complex.pmc"
PMC* _self;

#line 430 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
#line 434 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 1436 "./src/pmc/complex.pmc"

    PMC * const d = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    PMC * const e = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    #line 1854 "./src/pmc/complex.pmc"
Parrot_pcc_invoke_method_from_c_args(interp, _self, CONST_STRING_GEN(interp, "sin"), "->P", &d);
#line 1440 "./src/pmc/complex.pmc"

    #line 1858 "./src/pmc/complex.pmc"
Parrot_pcc_invoke_method_from_c_args(interp, _self, CONST_STRING_GEN(interp, "cos"), "->P", &e);
#line 1441 "./src/pmc/complex.pmc"


    Parrot_Complex_multi_i_divide_Complex(interp, d, e);

    #line 260 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *d */
#line 267 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "P", (PMC*)d);
    return;
    /*END RETURN PMC *d */
    }
#line 1445 "./src/pmc/complex.pmc"

#line 441 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 1881 "./src/pmc/complex.c"
}
static  void
Parrot_Complex_nci_cot(PARROT_INTERP, PMC *_self)
{
#line 422 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 1893 "./src/pmc/complex.pmc"
PMC* _self;

#line 430 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
#line 434 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 1448 "./src/pmc/complex.pmc"

    PMC * const d = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    PMC * const e = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    #line 1905 "./src/pmc/complex.pmc"
Parrot_pcc_invoke_method_from_c_args(interp, _self, CONST_STRING_GEN(interp, "cos"), "->P", &d);
#line 1451 "./src/pmc/complex.pmc"

    #line 1909 "./src/pmc/complex.pmc"
Parrot_pcc_invoke_method_from_c_args(interp, _self, CONST_STRING_GEN(interp, "sin"), "->P", &e);
#line 1452 "./src/pmc/complex.pmc"


    Parrot_Complex_multi_i_divide_Complex(interp, d, e);

    #line 260 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *d */
#line 267 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "P", (PMC*)d);
    return;
    /*END RETURN PMC *d */
    }
#line 1456 "./src/pmc/complex.pmc"

#line 441 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 1932 "./src/pmc/complex.c"
}
static  void
Parrot_Complex_nci_sec(PARROT_INTERP, PMC *_self)
{
#line 422 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 1944 "./src/pmc/complex.pmc"
PMC* _self;

#line 430 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
#line 434 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 1459 "./src/pmc/complex.pmc"

    PMC * const d = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    PMC * const e = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    SETATTR_Complex_re(interp, d, 1.0);
    SETATTR_Complex_im(interp, d, 0.0);
    #line 1958 "./src/pmc/complex.pmc"
Parrot_pcc_invoke_method_from_c_args(interp, _self, CONST_STRING_GEN(interp, "cos"), "->P", &e);
#line 1464 "./src/pmc/complex.pmc"


    Parrot_Complex_multi_i_divide_Complex(interp, d, e);

    #line 260 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *d */
#line 267 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "P", (PMC*)d);
    return;
    /*END RETURN PMC *d */
    }
#line 1468 "./src/pmc/complex.pmc"

#line 441 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 1981 "./src/pmc/complex.c"
}
static  void
Parrot_Complex_nci_csc(PARROT_INTERP, PMC *_self)
{
#line 422 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 1993 "./src/pmc/complex.pmc"
PMC* _self;

#line 430 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
#line 434 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 1471 "./src/pmc/complex.pmc"

    PMC * const d = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    PMC * const e = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    SETATTR_Complex_re(interp, d, 1.0);
    SETATTR_Complex_im(interp, d, 0.0);

    #line 2009 "./src/pmc/complex.pmc"
Parrot_pcc_invoke_method_from_c_args(interp, _self, CONST_STRING_GEN(interp, "sin"), "->P", &e);
#line 1478 "./src/pmc/complex.pmc"


    Parrot_Complex_multi_i_divide_Complex(interp, d, e);

    #line 260 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *d */
#line 267 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "P", (PMC*)d);
    return;
    /*END RETURN PMC *d */
    }
#line 1482 "./src/pmc/complex.pmc"

#line 441 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 2032 "./src/pmc/complex.c"
}
static  void
Parrot_Complex_nci_asin(PARROT_INTERP, PMC *_self)
{
#line 422 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 2044 "./src/pmc/complex.pmc"
PMC* _self;

#line 430 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
#line 434 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 1518 "./src/pmc/complex.pmc"

    FLOATVAL d_re, d_im, e_re, e_im, self_re, self_im;
    PMC * const d = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    PMC *       e = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    GETATTR_Complex_re(interp, _self, self_re);
    GETATTR_Complex_im(interp, _self, self_im);

    e      = Parrot_Complex_multi_multiply_Complex_PMC(interp, _self, _self, e);
    GETATTR_Complex_re(interp, e, e_re);
    GETATTR_Complex_im(interp, e, e_im);
    SETATTR_Complex_re(interp, e, 1.0 - e_re);
    SETATTR_Complex_im(interp, e, -e_im);

    #line 2066 "./src/pmc/complex.pmc"
Parrot_pcc_invoke_method_from_c_args(interp, e, CONST_STRING_GEN(interp, "sqrt"), "->P", &d);
#line 1531 "./src/pmc/complex.pmc"

    GETATTR_Complex_re(interp, d, d_re);
    GETATTR_Complex_im(interp, d, d_im);
    SETATTR_Complex_re(interp, d, d_re - self_im);
    SETATTR_Complex_im(interp, d, d_im + self_re);

    #line 2075 "./src/pmc/complex.pmc"
Parrot_pcc_invoke_method_from_c_args(interp, d, CONST_STRING_GEN(interp, "ln"), "->P", &d);
#line 1537 "./src/pmc/complex.pmc"

    GETATTR_Complex_re(interp, d, d_re);
    GETATTR_Complex_im(interp, d, d_im);
    SETATTR_Complex_re(interp, e, d_im);
    SETATTR_Complex_im(interp, e, d_re ? -d_re : 0.0);

    #line 260 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *e */
#line 267 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "P", (PMC*)e);
    return;
    /*END RETURN PMC *e */
    }
#line 1543 "./src/pmc/complex.pmc"

#line 441 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 2100 "./src/pmc/complex.c"
}
static  void
Parrot_Complex_nci_acos(PARROT_INTERP, PMC *_self)
{
#line 422 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 2112 "./src/pmc/complex.pmc"
PMC* _self;

#line 430 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
#line 434 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 1546 "./src/pmc/complex.pmc"

    FLOATVAL d_re, d_im, e_re, e_im, self_re, self_im;
    PMC * const d = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    PMC *       e = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    GETATTR_Complex_re(interp, _self, self_re);
    GETATTR_Complex_im(interp, _self, self_im);

    e = Parrot_Complex_multi_multiply_Complex_PMC(interp, _self, _self, e);
    GETATTR_Complex_re(interp, e, e_re);
    GETATTR_Complex_im(interp, e, e_im);
    SETATTR_Complex_re(interp, e, 1.0 - e_re);
    SETATTR_Complex_im(interp, e, -e_im);

    #line 2134 "./src/pmc/complex.pmc"
Parrot_pcc_invoke_method_from_c_args(interp, e, CONST_STRING_GEN(interp, "sqrt"), "->P", &d);
#line 1559 "./src/pmc/complex.pmc"

    GETATTR_Complex_re(interp, d, d_re);
    GETATTR_Complex_im(interp, d, d_im);
    SETATTR_Complex_re(interp, d, d_re + self_im);
    SETATTR_Complex_im(interp, d, d_im - self_re);

    #line 2143 "./src/pmc/complex.pmc"
Parrot_pcc_invoke_method_from_c_args(interp, d, CONST_STRING_GEN(interp, "ln"), "->P", &e);
#line 1565 "./src/pmc/complex.pmc"

    GETATTR_Complex_re(interp, e, e_re);
    GETATTR_Complex_im(interp, e, e_im);
    SETATTR_Complex_re(interp, d, e_im + 2.0 * atan(1.0));
    SETATTR_Complex_im(interp, d, e_re ? -e_re : 0.0);

    #line 260 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *d */
#line 267 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "P", (PMC*)d);
    return;
    /*END RETURN PMC *d */
    }
#line 1571 "./src/pmc/complex.pmc"

#line 441 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 2168 "./src/pmc/complex.c"
}
static  void
Parrot_Complex_nci_atan(PARROT_INTERP, PMC *_self)
{
#line 422 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 2180 "./src/pmc/complex.pmc"
PMC* _self;

#line 430 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
#line 434 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 1574 "./src/pmc/complex.pmc"

    PMC * const d  = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    PMC * const e  = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    FLOATVAL re, im, d_re, d_im;
    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);

    SETATTR_Complex_re(interp, d, re);
    SETATTR_Complex_im(interp, d, 1 + im);
    SETATTR_Complex_re(interp, e, -re);
    SETATTR_Complex_im(interp, e, 1 - im);

    Parrot_Complex_multi_i_divide_Complex(interp, d, e);

    #line 2203 "./src/pmc/complex.pmc"
Parrot_pcc_invoke_method_from_c_args(interp, d, CONST_STRING_GEN(interp, "ln"), "->P", &d);
#line 1588 "./src/pmc/complex.pmc"

    GETATTR_Complex_re(interp, d, d_re);
    GETATTR_Complex_im(interp, d, d_im);

    SETATTR_Complex_re(interp, e, (d_im ? d_im : -0.0) / -2.0);
    SETATTR_Complex_im(interp, e, d_re / 2.0);

    #line 260 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *e */
#line 267 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "P", (PMC*)e);
    return;
    /*END RETURN PMC *e */
    }
#line 1595 "./src/pmc/complex.pmc"

#line 441 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 2229 "./src/pmc/complex.c"
}
static  void
Parrot_Complex_nci_acot(PARROT_INTERP, PMC *_self)
{
#line 422 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 2241 "./src/pmc/complex.pmc"
PMC* _self;

#line 430 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
#line 434 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 1598 "./src/pmc/complex.pmc"

    PMC * const d = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    PMC     *e;
    FLOATVAL re, im;
    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);

    SETATTR_Complex_re(interp, d,  re / (re * re + im * im));
    SETATTR_Complex_im(interp, d, -im / (re * re + im * im));

    #line 2260 "./src/pmc/complex.pmc"
Parrot_pcc_invoke_method_from_c_args(interp, d, CONST_STRING_GEN(interp, "atan"), "->P", &e);
#line 1608 "./src/pmc/complex.pmc"

    #line 260 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *e */
#line 267 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "P", (PMC*)e);
    return;
    /*END RETURN PMC *e */
    }
#line 1609 "./src/pmc/complex.pmc"

#line 441 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 2280 "./src/pmc/complex.c"
}
static  void
Parrot_Complex_nci_acsc(PARROT_INTERP, PMC *_self)
{
#line 422 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 2292 "./src/pmc/complex.pmc"
PMC* _self;

#line 430 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
#line 434 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 1612 "./src/pmc/complex.pmc"

    PMC * const d = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    PMC     *e;
    FLOATVAL re, im;
    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);

    SETATTR_Complex_re(interp, d,  re / (re * re + im * im));
    SETATTR_Complex_im(interp, d, -im / (re * re + im * im));

    #line 2311 "./src/pmc/complex.pmc"
Parrot_pcc_invoke_method_from_c_args(interp, d, CONST_STRING_GEN(interp, "asin"), "->P", &e);
#line 1622 "./src/pmc/complex.pmc"

    #line 260 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *e */
#line 267 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "P", (PMC*)e);
    return;
    /*END RETURN PMC *e */
    }
#line 1623 "./src/pmc/complex.pmc"

#line 441 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 2331 "./src/pmc/complex.c"
}
static  void
Parrot_Complex_nci_asec(PARROT_INTERP, PMC *_self)
{
#line 422 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 2343 "./src/pmc/complex.pmc"
PMC* _self;

#line 430 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
#line 434 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 1626 "./src/pmc/complex.pmc"

    PMC * const d = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    PMC     *e;
    FLOATVAL re, im;
    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);

    SETATTR_Complex_re(interp, d,  re / (re * re + im * im));
    SETATTR_Complex_im(interp, d, -im / (re * re + im * im));

    #line 2362 "./src/pmc/complex.pmc"
Parrot_pcc_invoke_method_from_c_args(interp, d, CONST_STRING_GEN(interp, "acos"), "->P", &e);
#line 1636 "./src/pmc/complex.pmc"

    #line 260 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *e */
#line 267 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "P", (PMC*)e);
    return;
    /*END RETURN PMC *e */
    }
#line 1637 "./src/pmc/complex.pmc"

#line 441 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 2382 "./src/pmc/complex.c"
}
static  void
Parrot_Complex_nci_sinh(PARROT_INTERP, PMC *_self)
{
#line 422 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 2394 "./src/pmc/complex.pmc"
PMC* _self;

#line 430 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
#line 434 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 1660 "./src/pmc/complex.pmc"

    PMC * const d = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    FLOATVAL re, im;
    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);

    SETATTR_Complex_re(interp, d, sinh(re) * cos(im));
    SETATTR_Complex_im(interp, d, im ? cosh(re) * sin(im) : 0.0);

    #line 260 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *d */
#line 267 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "P", (PMC*)d);
    return;
    /*END RETURN PMC *d */
    }
#line 1669 "./src/pmc/complex.pmc"

#line 441 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 2428 "./src/pmc/complex.c"
}
static  void
Parrot_Complex_nci_cosh(PARROT_INTERP, PMC *_self)
{
#line 422 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 2440 "./src/pmc/complex.pmc"
PMC* _self;

#line 430 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
#line 434 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 1672 "./src/pmc/complex.pmc"

    PMC * const d = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    FLOATVAL re, im;
    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);

    SETATTR_Complex_re(interp, d, cosh(re) * cos(im));
    if (re == 0.0 || im == 0.0) {
        SETATTR_Complex_im(interp, d, 0.0);
    }
    else {
        SETATTR_Complex_im(interp, d, sinh(re) * sin(im));
    }

    #line 260 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *d */
#line 267 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "P", (PMC*)d);
    return;
    /*END RETURN PMC *d */
    }
#line 1686 "./src/pmc/complex.pmc"

#line 441 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 2479 "./src/pmc/complex.c"
}
static  void
Parrot_Complex_nci_tanh(PARROT_INTERP, PMC *_self)
{
#line 422 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 2491 "./src/pmc/complex.pmc"
PMC* _self;

#line 430 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
#line 434 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 1689 "./src/pmc/complex.pmc"

    PMC * const d = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    PMC * const e = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    #line 2504 "./src/pmc/complex.pmc"
Parrot_pcc_invoke_method_from_c_args(interp, _self, CONST_STRING_GEN(interp, "sinh"), "->P", &d);
#line 1693 "./src/pmc/complex.pmc"

    #line 2508 "./src/pmc/complex.pmc"
Parrot_pcc_invoke_method_from_c_args(interp, _self, CONST_STRING_GEN(interp, "cosh"), "->P", &e);
#line 1694 "./src/pmc/complex.pmc"


    Parrot_Complex_multi_i_divide_Complex(interp, d, e);

    #line 260 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *d */
#line 267 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "P", (PMC*)d);
    return;
    /*END RETURN PMC *d */
    }
#line 1698 "./src/pmc/complex.pmc"

#line 441 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 2531 "./src/pmc/complex.c"
}
static  void
Parrot_Complex_nci_coth(PARROT_INTERP, PMC *_self)
{
#line 422 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 2543 "./src/pmc/complex.pmc"
PMC* _self;

#line 430 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
#line 434 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 1701 "./src/pmc/complex.pmc"

    FLOATVAL re, im;
    PMC * const d = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    #line 2556 "./src/pmc/complex.pmc"
Parrot_pcc_invoke_method_from_c_args(interp, _self, CONST_STRING_GEN(interp, "tanh"), "->P", &d);
#line 1705 "./src/pmc/complex.pmc"

    GETATTR_Complex_re(interp, d, re);
    GETATTR_Complex_im(interp, d, im);

    SETATTR_Complex_re(interp, d, re ?  re / (re * re + im * im) : 0.0);
    SETATTR_Complex_im(interp, d, im ? -im / (re * re + im * im) : 0.0);

    #line 260 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *d */
#line 267 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "P", (PMC*)d);
    return;
    /*END RETURN PMC *d */
    }
#line 1712 "./src/pmc/complex.pmc"

#line 441 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 2582 "./src/pmc/complex.c"
}
static  void
Parrot_Complex_nci_csch(PARROT_INTERP, PMC *_self)
{
#line 422 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 2594 "./src/pmc/complex.pmc"
PMC* _self;

#line 430 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
#line 434 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 1715 "./src/pmc/complex.pmc"

    FLOATVAL re, im;
    PMC * const d = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    #line 2607 "./src/pmc/complex.pmc"
Parrot_pcc_invoke_method_from_c_args(interp, _self, CONST_STRING_GEN(interp, "sinh"), "->P", &d);
#line 1719 "./src/pmc/complex.pmc"

    GETATTR_Complex_re(interp, d, re);
    GETATTR_Complex_im(interp, d, im);

    SETATTR_Complex_re(interp, d, re ?  re / (re * re + im * im) : 0.0);
    SETATTR_Complex_im(interp, d, im ? -im / (re * re + im * im) : 0.0);

    #line 260 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *d */
#line 267 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "P", (PMC*)d);
    return;
    /*END RETURN PMC *d */
    }
#line 1726 "./src/pmc/complex.pmc"

#line 441 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 2633 "./src/pmc/complex.c"
}
static  void
Parrot_Complex_nci_sech(PARROT_INTERP, PMC *_self)
{
#line 422 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 2645 "./src/pmc/complex.pmc"
PMC* _self;

#line 430 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
#line 434 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 1729 "./src/pmc/complex.pmc"

    FLOATVAL re, im;
    PMC * const d = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    #line 2658 "./src/pmc/complex.pmc"
Parrot_pcc_invoke_method_from_c_args(interp, _self, CONST_STRING_GEN(interp, "cosh"), "->P", &d);
#line 1733 "./src/pmc/complex.pmc"

    GETATTR_Complex_re(interp, d, re);
    GETATTR_Complex_im(interp, d, im);

    SETATTR_Complex_re(interp, d, re ?  re / (re * re + im * im) : 0.0);
    SETATTR_Complex_im(interp, d, im ? -im / (re * re + im * im) : 0.0);

    #line 260 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *d */
#line 267 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "P", (PMC*)d);
    return;
    /*END RETURN PMC *d */
    }
#line 1740 "./src/pmc/complex.pmc"

#line 441 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 2684 "./src/pmc/complex.c"
}
static  void
Parrot_Complex_nci_asinh(PARROT_INTERP, PMC *_self)
{
#line 422 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 2696 "./src/pmc/complex.pmc"
PMC* _self;

#line 430 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
#line 434 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 1771 "./src/pmc/complex.pmc"

    FLOATVAL re, im;
    PMC * const d = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    PMC * const e = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);
    SETATTR_Complex_re(interp, d,  im);
    SETATTR_Complex_im(interp, d, -re);

    #line 2715 "./src/pmc/complex.pmc"
Parrot_pcc_invoke_method_from_c_args(interp, d, CONST_STRING_GEN(interp, "asin"), "->P", &d);
#line 1781 "./src/pmc/complex.pmc"

    GETATTR_Complex_re(interp, d, re);
    GETATTR_Complex_im(interp, d, im);
    SETATTR_Complex_re(interp, e, -im);
    SETATTR_Complex_im(interp, e,  re);

    #line 260 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *e */
#line 267 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "P", (PMC*)e);
    return;
    /*END RETURN PMC *e */
    }
#line 1787 "./src/pmc/complex.pmc"

#line 441 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 2740 "./src/pmc/complex.c"
}
static  void
Parrot_Complex_nci_acosh(PARROT_INTERP, PMC *_self)
{
#line 422 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 2752 "./src/pmc/complex.pmc"
PMC* _self;

#line 430 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
#line 434 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 1790 "./src/pmc/complex.pmc"

    FLOATVAL re, im;
    PMC * const d = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    PMC * const e = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    #line 2766 "./src/pmc/complex.pmc"
Parrot_pcc_invoke_method_from_c_args(interp, _self, CONST_STRING_GEN(interp, "acos"), "->P", &d);
#line 1795 "./src/pmc/complex.pmc"

    GETATTR_Complex_re(interp, d, re);
    GETATTR_Complex_im(interp, d, im);
    SETATTR_Complex_re(interp, e, -im);
    SETATTR_Complex_im(interp, e,  re);

    #line 260 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *e */
#line 267 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "P", (PMC*)e);
    return;
    /*END RETURN PMC *e */
    }
#line 1801 "./src/pmc/complex.pmc"

#line 441 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 2791 "./src/pmc/complex.c"
}
static  void
Parrot_Complex_nci_atanh(PARROT_INTERP, PMC *_self)
{
#line 422 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 2803 "./src/pmc/complex.pmc"
PMC* _self;

#line 430 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
#line 434 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 1804 "./src/pmc/complex.pmc"

    FLOATVAL re, im;
    PMC * const d = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    PMC * const e = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);
    SETATTR_Complex_re(interp, d,  im);
    SETATTR_Complex_im(interp, d, -re);

    #line 2822 "./src/pmc/complex.pmc"
Parrot_pcc_invoke_method_from_c_args(interp, d, CONST_STRING_GEN(interp, "atan"), "->P", &d);
#line 1814 "./src/pmc/complex.pmc"

    GETATTR_Complex_re(interp, d, re);
    GETATTR_Complex_im(interp, d, im);
    SETATTR_Complex_re(interp, e, -im);
    SETATTR_Complex_im(interp, e,  re);

    #line 260 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *e */
#line 267 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "P", (PMC*)e);
    return;
    /*END RETURN PMC *e */
    }
#line 1820 "./src/pmc/complex.pmc"

#line 441 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 2847 "./src/pmc/complex.c"
}
static  void
Parrot_Complex_nci_acoth(PARROT_INTERP, PMC *_self)
{
#line 422 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 2859 "./src/pmc/complex.pmc"
PMC* _self;

#line 430 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
#line 434 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 1823 "./src/pmc/complex.pmc"

    PMC * const d = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    PMC     *e;
    FLOATVAL re, im;
    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);

    SETATTR_Complex_re(interp, d,  re / (re * re + im * im));
    SETATTR_Complex_im(interp, d, -im / (re * re + im * im));

    #line 2878 "./src/pmc/complex.pmc"
Parrot_pcc_invoke_method_from_c_args(interp, d, CONST_STRING_GEN(interp, "atanh"), "->P", &e);
#line 1833 "./src/pmc/complex.pmc"

    #line 260 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *e */
#line 267 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "P", (PMC*)e);
    return;
    /*END RETURN PMC *e */
    }
#line 1834 "./src/pmc/complex.pmc"

#line 441 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 2898 "./src/pmc/complex.c"
}
static  void
Parrot_Complex_nci_acsch(PARROT_INTERP, PMC *_self)
{
#line 422 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 2910 "./src/pmc/complex.pmc"
PMC* _self;

#line 430 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
#line 434 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 1837 "./src/pmc/complex.pmc"

    PMC * const d = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    PMC     *e;
    FLOATVAL re, im;
    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);

    SETATTR_Complex_re(interp, d,  re / (re * re + im * im));
    SETATTR_Complex_im(interp, d, -im / (re * re + im * im));

    #line 2929 "./src/pmc/complex.pmc"
Parrot_pcc_invoke_method_from_c_args(interp, d, CONST_STRING_GEN(interp, "asinh"), "->P", &e);
#line 1847 "./src/pmc/complex.pmc"

    #line 260 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *e */
#line 267 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "P", (PMC*)e);
    return;
    /*END RETURN PMC *e */
    }
#line 1848 "./src/pmc/complex.pmc"

#line 441 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 2949 "./src/pmc/complex.c"
}
static  void
Parrot_Complex_nci_asech(PARROT_INTERP, PMC *_self)
{
#line 422 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 2961 "./src/pmc/complex.pmc"
PMC* _self;

#line 430 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
#line 434 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 1851 "./src/pmc/complex.pmc"

    PMC * const d = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    PMC     *e;
    FLOATVAL re, im;
    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);

    SETATTR_Complex_re(interp, d,  re / (re * re + im * im));
    SETATTR_Complex_im(interp, d, -im / (re * re + im * im));

    #line 2980 "./src/pmc/complex.pmc"
Parrot_pcc_invoke_method_from_c_args(interp, d, CONST_STRING_GEN(interp, "acosh"), "->P", &e);
#line 1861 "./src/pmc/complex.pmc"

    #line 260 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *e */
#line 267 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "P", (PMC*)e);
    return;
    /*END RETURN PMC *e */
    }
#line 1862 "./src/pmc/complex.pmc"

#line 441 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 3000 "./src/pmc/complex.c"
}
static  void
Parrot_Complex_nci_pow(PARROT_INTERP, PMC *_self)
{
#line 422 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 3012 "./src/pmc/complex.pmc"
PMC* _self;
PMC* value;

#line 430 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiP",
            &_self, &value);
#line 434 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 1887 "./src/pmc/complex.pmc"

    PMC *l = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    PMC *log;
    PMC *dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    Parrot_pcc_invoke_method_from_c_args(interp, _self, CONST_STRING(interp, "ln"),
                "->P", &log);

    l = VTABLE_multiply(interp, log, value, l);

    Parrot_pcc_invoke_method_from_c_args(interp, l, CONST_STRING(interp, "exp"),
                "->P", &dest);
    #line 260 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *dest */
#line 267 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "P", (PMC*)dest);
    return;
    /*END RETURN PMC *dest */
    }
#line 1899 "./src/pmc/complex.pmc"

#line 441 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 3050 "./src/pmc/complex.c"
}
static  void
Parrot_Complex_nci_sqrt(PARROT_INTERP, PMC *_self)
{
#line 422 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 3062 "./src/pmc/complex.pmc"
PMC* _self;

#line 430 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
#line 434 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 1902 "./src/pmc/complex.pmc"

    PMC * const result = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    const FLOATVAL absval = _self->vtable->get_number(interp, _self);
    FLOATVAL sx, sy, rx, ry;
    GETATTR_Complex_re(interp, _self, sx);
    GETATTR_Complex_im(interp, _self, sy);

    rx = sqrt((absval + sx) / 2);
    ry = sqrt((absval - sx) / 2);
    if (sy < 0)
        ry = -ry;
    SETATTR_Complex_re(interp, result, rx);
    SETATTR_Complex_im(interp, result, ry);
    #line 260 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *result */
#line 267 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "P", (PMC*)result);
    return;
    /*END RETURN PMC *result */
    }
#line 1915 "./src/pmc/complex.pmc"

#line 441 "/builddir/build/BUILD/parrot-2.8.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 3100 "./src/pmc/complex.c"
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_Complex_update_vtable(VTABLE *vt) {
    vt->absolute = Parrot_Complex_absolute;
    vt->add = Parrot_Complex_add;
    vt->add_float = Parrot_Complex_add_float;
    vt->add_int = Parrot_Complex_add_int;
    vt->clone = Parrot_Complex_clone;
    vt->divide = Parrot_Complex_divide;
    vt->divide_float = Parrot_Complex_divide_float;
    vt->divide_int = Parrot_Complex_divide_int;
    vt->freeze = Parrot_Complex_freeze;
    vt->get_bool = Parrot_Complex_get_bool;
    vt->get_integer = Parrot_Complex_get_integer;
    vt->get_integer_keyed = Parrot_Complex_get_integer_keyed;
    vt->get_integer_keyed_str = Parrot_Complex_get_integer_keyed_str;
    vt->get_number = Parrot_Complex_get_number;
    vt->get_number_keyed = Parrot_Complex_get_number_keyed;
    vt->get_number_keyed_int = Parrot_Complex_get_number_keyed_int;
    vt->get_number_keyed_str = Parrot_Complex_get_number_keyed_str;
    vt->get_pmc_keyed = Parrot_Complex_get_pmc_keyed;
    vt->get_pmc_keyed_int = Parrot_Complex_get_pmc_keyed_int;
    vt->get_pmc_keyed_str = Parrot_Complex_get_pmc_keyed_str;
    vt->get_string = Parrot_Complex_get_string;
    vt->i_absolute = Parrot_Complex_i_absolute;
    vt->i_add = Parrot_Complex_i_add;
    vt->i_add_float = Parrot_Complex_i_add_float;
    vt->i_add_int = Parrot_Complex_i_add_int;
    vt->i_divide = Parrot_Complex_i_divide;
    vt->i_divide_float = Parrot_Complex_i_divide_float;
    vt->i_divide_int = Parrot_Complex_i_divide_int;
    vt->i_multiply = Parrot_Complex_i_multiply;
    vt->i_multiply_float = Parrot_Complex_i_multiply_float;
    vt->i_multiply_int = Parrot_Complex_i_multiply_int;
    vt->i_neg = Parrot_Complex_i_neg;
    vt->i_subtract = Parrot_Complex_i_subtract;
    vt->i_subtract_float = Parrot_Complex_i_subtract_float;
    vt->i_subtract_int = Parrot_Complex_i_subtract_int;
    vt->init = Parrot_Complex_init;
    vt->init_pmc = Parrot_Complex_init_pmc;
    vt->is_equal = Parrot_Complex_is_equal;
    vt->multiply = Parrot_Complex_multiply;
    vt->multiply_float = Parrot_Complex_multiply_float;
    vt->multiply_int = Parrot_Complex_multiply_int;
    vt->neg = Parrot_Complex_neg;
    vt->set_integer_keyed = Parrot_Complex_set_integer_keyed;
    vt->set_integer_keyed_str = Parrot_Complex_set_integer_keyed_str;
    vt->set_integer_native = Parrot_Complex_set_integer_native;
    vt->set_number_keyed = Parrot_Complex_set_number_keyed;
    vt->set_number_keyed_int = Parrot_Complex_set_number_keyed_int;
    vt->set_number_keyed_str = Parrot_Complex_set_number_keyed_str;
    vt->set_number_native = Parrot_Complex_set_number_native;
    vt->set_pmc = Parrot_Complex_set_pmc;
    vt->set_pmc_keyed = Parrot_Complex_set_pmc_keyed;
    vt->set_pmc_keyed_str = Parrot_Complex_set_pmc_keyed_str;
    vt->set_string_native = Parrot_Complex_set_string_native;
    vt->subtract = Parrot_Complex_subtract;
    vt->subtract_float = Parrot_Complex_subtract_float;
    vt->subtract_int = Parrot_Complex_subtract_int;
    vt->thaw = Parrot_Complex_thaw;
    vt->attr_size = sizeof(Parrot_Complex_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_Complex_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->absolute = Parrot_Complex_absolute;
    vt->add = Parrot_Complex_add;
    vt->add_float = Parrot_Complex_add_float;
    vt->add_int = Parrot_Complex_add_int;
    vt->clone = Parrot_Complex_clone;
    vt->divide = Parrot_Complex_divide;
    vt->divide_float = Parrot_Complex_divide_float;
    vt->divide_int = Parrot_Complex_divide_int;
    vt->freeze = Parrot_Complex_freeze;
    vt->get_bool = Parrot_Complex_get_bool;
    vt->get_integer = Parrot_Complex_get_integer;
    vt->get_integer_keyed = Parrot_Complex_get_integer_keyed;
    vt->get_integer_keyed_str = Parrot_Complex_get_integer_keyed_str;
    vt->get_number = Parrot_Complex_get_number;
    vt->get_number_keyed = Parrot_Complex_get_number_keyed;
    vt->get_number_keyed_int = Parrot_Complex_get_number_keyed_int;
    vt->get_number_keyed_str = Parrot_Complex_get_number_keyed_str;
    vt->get_pmc_keyed = Parrot_Complex_get_pmc_keyed;
    vt->get_pmc_keyed_int = Parrot_Complex_get_pmc_keyed_int;
    vt->get_pmc_keyed_str = Parrot_Complex_get_pmc_keyed_str;
    vt->get_string = Parrot_Complex_get_string;
    vt->init = Parrot_Complex_init;
    vt->init_pmc = Parrot_Complex_init_pmc;
    vt->is_equal = Parrot_Complex_is_equal;
    vt->multiply = Parrot_Complex_multiply;
    vt->multiply_float = Parrot_Complex_multiply_float;
    vt->multiply_int = Parrot_Complex_multiply_int;
    vt->neg = Parrot_Complex_neg;
    vt->subtract = Parrot_Complex_subtract;
    vt->subtract_float = Parrot_Complex_subtract_float;
    vt->subtract_int = Parrot_Complex_subtract_int;
    vt->attr_size = sizeof(Parrot_Complex_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Complex_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_get_vtable(interp);
    Parrot_Complex_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Complex_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_ro_get_vtable(interp);
    Parrot_Complex_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_Complex_get_mro(PARROT_INTERP, ARGIN_NULLOK(PMC* mro)) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }

    VTABLE_unshift_string(interp, mro,
        Parrot_str_new_init(interp, "Complex", 7,
            Parrot_default_encoding_ptr, 0));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_Complex_get_isa(PARROT_INTERP, ARGIN_NULLOK(Hash* isa)) {
    if (isa == NULL) {
        isa = parrot_new_hash(interp);
    }
    parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "Complex")), PMCNULL);
    return isa;
}

void
Parrot_Complex_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "Fre Fim ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_Complex_get_vtable(interp);
        vt->base_type      = enum_class_Complex;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "Complex");
        vt->provides_str = CONST_STRING_GEN(interp, "scalar complex");
        vt->isa_hash     = Parrot_Complex_get_isa(interp, NULL);
        {
            VTABLE                   *vt_ro;
            vt_ro                 = Parrot_Complex_ro_get_vtable(interp);
            vt_ro->base_type      = enum_class_Complex;
            vt_ro->flags          = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable      = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_Complex_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        {
            STRING *method_name = CONST_STRING_GEN(interp, "ln");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Complex_nci_ln),
                method_name, signature);
        }
        {
            STRING *method_name = CONST_STRING_GEN(interp, "exp");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Complex_nci_exp),
                method_name, signature);
        }
        {
            STRING *method_name = CONST_STRING_GEN(interp, "sin");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Complex_nci_sin),
                method_name, signature);
        }
        {
            STRING *method_name = CONST_STRING_GEN(interp, "cos");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Complex_nci_cos),
                method_name, signature);
        }
        {
            STRING *method_name = CONST_STRING_GEN(interp, "tan");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Complex_nci_tan),
                method_name, signature);
        }
        {
            STRING *method_name = CONST_STRING_GEN(interp, "cot");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Complex_nci_cot),
                method_name, signature);
        }
        {
            STRING *method_name = CONST_STRING_GEN(interp, "sec");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Complex_nci_sec),
                method_name, signature);
        }
        {
            STRING *method_name = CONST_STRING_GEN(interp, "csc");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Complex_nci_csc),
                method_name, signature);
        }
        {
            STRING *method_name = CONST_STRING_GEN(interp, "asin");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Complex_nci_asin),
                method_name, signature);
        }
        {
            STRING *method_name = CONST_STRING_GEN(interp, "acos");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Complex_nci_acos),
                method_name, signature);
        }
        {
            STRING *method_name = CONST_STRING_GEN(interp, "atan");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Complex_nci_atan),
                method_name, signature);
        }
        {
            STRING *method_name = CONST_STRING_GEN(interp, "acot");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Complex_nci_acot),
                method_name, signature);
        }
        {
            STRING *method_name = CONST_STRING_GEN(interp, "acsc");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Complex_nci_acsc),
                method_name, signature);
        }
        {
            STRING *method_name = CONST_STRING_GEN(interp, "asec");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Complex_nci_asec),
                method_name, signature);
        }
        {
            STRING *method_name = CONST_STRING_GEN(interp, "sinh");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Complex_nci_sinh),
                method_name, signature);
        }
        {
            STRING *method_name = CONST_STRING_GEN(interp, "cosh");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Complex_nci_cosh),
                method_name, signature);
        }
        {
            STRING *method_name = CONST_STRING_GEN(interp, "tanh");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Complex_nci_tanh),
                method_name, signature);
        }
        {
            STRING *method_name = CONST_STRING_GEN(interp, "coth");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Complex_nci_coth),
                method_name, signature);
        }
        {
            STRING *method_name = CONST_STRING_GEN(interp, "csch");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Complex_nci_csch),
                method_name, signature);
        }
        {
            STRING *method_name = CONST_STRING_GEN(interp, "sech");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Complex_nci_sech),
                method_name, signature);
        }
        {
            STRING *method_name = CONST_STRING_GEN(interp, "asinh");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Complex_nci_asinh),
                method_name, signature);
        }
        {
            STRING *method_name = CONST_STRING_GEN(interp, "acosh");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Complex_nci_acosh),
                method_name, signature);
        }
        {
            STRING *method_name = CONST_STRING_GEN(interp, "atanh");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Complex_nci_atanh),
                method_name, signature);
        }
        {
            STRING *method_name = CONST_STRING_GEN(interp, "acoth");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Complex_nci_acoth),
                method_name, signature);
        }
        {
            STRING *method_name = CONST_STRING_GEN(interp, "acsch");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Complex_nci_acsch),
                method_name, signature);
        }
        {
            STRING *method_name = CONST_STRING_GEN(interp, "asech");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Complex_nci_asech),
                method_name, signature);
        }
        {
            STRING *method_name = CONST_STRING_GEN(interp, "pow");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Complex_nci_pow),
                method_name, signature);
        }
        {
            STRING *method_name = CONST_STRING_GEN(interp, "sqrt");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Complex_nci_sqrt),
                method_name, signature);
        }
        {
            STRING * const mfl_0 = CONST_STRING_GEN(interp, "add");
            STRING * const mfl_1 = CONST_STRING_GEN(interp, "PJPPP");
            STRING * const mfl_2 = CONST_STRING_GEN(interp, "Complex,Complex,PMC");
            STRING * const mfl_3 = CONST_STRING_GEN(interp, "Complex");
            STRING * const mfl_4 = CONST_STRING_GEN(interp, "Complex,DEFAULT,PMC");
            STRING * const mfl_5 = CONST_STRING_GEN(interp, "i_add");
            STRING * const mfl_6 = CONST_STRING_GEN(interp, "vJPP");
            STRING * const mfl_7 = CONST_STRING_GEN(interp, "Complex,Complex");
            STRING * const mfl_8 = CONST_STRING_GEN(interp, "Complex,DEFAULT");
            STRING * const mfl_9 = CONST_STRING_GEN(interp, "subtract");
            STRING * const mfl_10 = CONST_STRING_GEN(interp, "i_subtract");
            STRING * const mfl_11 = CONST_STRING_GEN(interp, "multiply");
            STRING * const mfl_12 = CONST_STRING_GEN(interp, "i_multiply");
            STRING * const mfl_13 = CONST_STRING_GEN(interp, "divide");
            STRING * const mfl_14 = CONST_STRING_GEN(interp, "i_divide");
            STRING * const mfl_15 = CONST_STRING_GEN(interp, "is_equal");
            STRING * const mfl_16 = CONST_STRING_GEN(interp, "IJPP");

            multi_func_list _temp_multi_func_list[18];
            _temp_multi_func_list[0].multi_name = mfl_0;
            _temp_multi_func_list[0].short_sig = mfl_1;
            _temp_multi_func_list[0].full_sig = mfl_2;
            _temp_multi_func_list[0].ns_name = mfl_3;
            _temp_multi_func_list[0].func_ptr = (funcptr_t) Parrot_Complex_multi_add_Complex_PMC;

            _temp_multi_func_list[1].multi_name = mfl_0;
            _temp_multi_func_list[1].short_sig = mfl_1;
            _temp_multi_func_list[1].full_sig = mfl_4;
            _temp_multi_func_list[1].ns_name = mfl_3;
            _temp_multi_func_list[1].func_ptr = (funcptr_t) Parrot_Complex_multi_add_DEFAULT_PMC;

            _temp_multi_func_list[2].multi_name = mfl_5;
            _temp_multi_func_list[2].short_sig = mfl_6;
            _temp_multi_func_list[2].full_sig = mfl_7;
            _temp_multi_func_list[2].ns_name = mfl_3;
            _temp_multi_func_list[2].func_ptr = (funcptr_t) Parrot_Complex_multi_i_add_Complex;

            _temp_multi_func_list[3].multi_name = mfl_5;
            _temp_multi_func_list[3].short_sig = mfl_6;
            _temp_multi_func_list[3].full_sig = mfl_8;
            _temp_multi_func_list[3].ns_name = mfl_3;
            _temp_multi_func_list[3].func_ptr = (funcptr_t) Parrot_Complex_multi_i_add_DEFAULT;

            _temp_multi_func_list[4].multi_name = mfl_9;
            _temp_multi_func_list[4].short_sig = mfl_1;
            _temp_multi_func_list[4].full_sig = mfl_2;
            _temp_multi_func_list[4].ns_name = mfl_3;
            _temp_multi_func_list[4].func_ptr = (funcptr_t) Parrot_Complex_multi_subtract_Complex_PMC;

            _temp_multi_func_list[5].multi_name = mfl_9;
            _temp_multi_func_list[5].short_sig = mfl_1;
            _temp_multi_func_list[5].full_sig = mfl_4;
            _temp_multi_func_list[5].ns_name = mfl_3;
            _temp_multi_func_list[5].func_ptr = (funcptr_t) Parrot_Complex_multi_subtract_DEFAULT_PMC;

            _temp_multi_func_list[6].multi_name = mfl_10;
            _temp_multi_func_list[6].short_sig = mfl_6;
            _temp_multi_func_list[6].full_sig = mfl_7;
            _temp_multi_func_list[6].ns_name = mfl_3;
            _temp_multi_func_list[6].func_ptr = (funcptr_t) Parrot_Complex_multi_i_subtract_Complex;

            _temp_multi_func_list[7].multi_name = mfl_10;
            _temp_multi_func_list[7].short_sig = mfl_6;
            _temp_multi_func_list[7].full_sig = mfl_8;
            _temp_multi_func_list[7].ns_name = mfl_3;
            _temp_multi_func_list[7].func_ptr = (funcptr_t) Parrot_Complex_multi_i_subtract_DEFAULT;

            _temp_multi_func_list[8].multi_name = mfl_11;
            _temp_multi_func_list[8].short_sig = mfl_1;
            _temp_multi_func_list[8].full_sig = mfl_2;
            _temp_multi_func_list[8].ns_name = mfl_3;
            _temp_multi_func_list[8].func_ptr = (funcptr_t) Parrot_Complex_multi_multiply_Complex_PMC;

            _temp_multi_func_list[9].multi_name = mfl_11;
            _temp_multi_func_list[9].short_sig = mfl_1;
            _temp_multi_func_list[9].full_sig = mfl_4;
            _temp_multi_func_list[9].ns_name = mfl_3;
            _temp_multi_func_list[9].func_ptr = (funcptr_t) Parrot_Complex_multi_multiply_DEFAULT_PMC;

            _temp_multi_func_list[10].multi_name = mfl_12;
            _temp_multi_func_list[10].short_sig = mfl_6;
            _temp_multi_func_list[10].full_sig = mfl_7;
            _temp_multi_func_list[10].ns_name = mfl_3;
            _temp_multi_func_list[10].func_ptr = (funcptr_t) Parrot_Complex_multi_i_multiply_Complex;

            _temp_multi_func_list[11].multi_name = mfl_12;
            _temp_multi_func_list[11].short_sig = mfl_6;
            _temp_multi_func_list[11].full_sig = mfl_8;
            _temp_multi_func_list[11].ns_name = mfl_3;
            _temp_multi_func_list[11].func_ptr = (funcptr_t) Parrot_Complex_multi_i_multiply_DEFAULT;

            _temp_multi_func_list[12].multi_name = mfl_13;
            _temp_multi_func_list[12].short_sig = mfl_1;
            _temp_multi_func_list[12].full_sig = mfl_2;
            _temp_multi_func_list[12].ns_name = mfl_3;
            _temp_multi_func_list[12].func_ptr = (funcptr_t) Parrot_Complex_multi_divide_Complex_PMC;

            _temp_multi_func_list[13].multi_name = mfl_13;
            _temp_multi_func_list[13].short_sig = mfl_1;
            _temp_multi_func_list[13].full_sig = mfl_4;
            _temp_multi_func_list[13].ns_name = mfl_3;
            _temp_multi_func_list[13].func_ptr = (funcptr_t) Parrot_Complex_multi_divide_DEFAULT_PMC;

            _temp_multi_func_list[14].multi_name = mfl_14;
            _temp_multi_func_list[14].short_sig = mfl_6;
            _temp_multi_func_list[14].full_sig = mfl_7;
            _temp_multi_func_list[14].ns_name = mfl_3;
            _temp_multi_func_list[14].func_ptr = (funcptr_t) Parrot_Complex_multi_i_divide_Complex;

            _temp_multi_func_list[15].multi_name = mfl_14;
            _temp_multi_func_list[15].short_sig = mfl_6;
            _temp_multi_func_list[15].full_sig = mfl_8;
            _temp_multi_func_list[15].ns_name = mfl_3;
            _temp_multi_func_list[15].func_ptr = (funcptr_t) Parrot_Complex_multi_i_divide_DEFAULT;

            _temp_multi_func_list[16].multi_name = mfl_15;
            _temp_multi_func_list[16].short_sig = mfl_16;
            _temp_multi_func_list[16].full_sig = mfl_7;
            _temp_multi_func_list[16].ns_name = mfl_3;
            _temp_multi_func_list[16].func_ptr = (funcptr_t) Parrot_Complex_multi_is_equal_Complex;

            _temp_multi_func_list[17].multi_name = mfl_15;
            _temp_multi_func_list[17].short_sig = mfl_16;
            _temp_multi_func_list[17].full_sig = mfl_8;
            _temp_multi_func_list[17].ns_name = mfl_3;
            _temp_multi_func_list[17].func_ptr = (funcptr_t) Parrot_Complex_multi_is_equal_DEFAULT;

            Parrot_mmd_add_multi_list_from_c_args(interp,
                _temp_multi_func_list, 18);
        }
    } /* pass */
} /* Parrot_Complex_class_init */
#line 1917 "./src/pmc/complex.pmc"


/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
